#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <windowsX.h>
#include <commdlg.h>
#include <shellapi.h>
#include <richedit.h>
#include <commctrl.h>
#include "akelpad.h"
#include "edit.h"

extern BOOL bInsertstate;
extern BOOL bUnixNewLine;
extern BOOL bModified;
extern OPENFILENAME ofn;
extern BOOL bStatusBar;
extern BOOL bOnTop;
extern BOOL bWordWrap;
extern BOOL bSaveTime;
extern BOOL bSingleOpen;
extern BOOL bKeepSpace;
extern BOOL bCurrentBOM;
extern PAGESETUPDLG psdPage;
extern LOGFONT logfont;
extern int nDefaultCodePage;
extern int nCurrentCodePage;
extern int nAnsiCodePage;
extern int nOemCodePage;
extern int nRecentFiles;
extern char (*szRecentNames)[MAX_PATH];
extern char szFileBuffer[];
extern char szCurrentFile[];
extern char szCommand[];

HINSTANCE hInstance;
char *lpCmdLine;
int nCmdShow=0;
STARTUPINFO lpStartupInfo;

char buf[BUFFER_SIZE];
char buf2[BUFFER_SIZE];
char szExeDir[MAX_PATH]="";
char szLangModule[MAX_PATH]="";
HMODULE hLangLib;
LANGID wSystemLanguage;
int nLangModules=0;
HWND hMainWnd;
HWND hSyncWindow;
HWND hStatus;
HWND hDlgModeless=NULL;
HMENU hMenu;
UINT uiOpenOnStartMessage;

BOOL bOldRichEdit;
BOOL bUnicode;
BOOL bGlobalPrint=FALSE;
int nMaxChars=0x0FFFFFFF;
int nMcstep=0x0FFFFFFF;
RECT rcMainWindow={CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT};
CHARRANGE chrg={0, 0};
int nPosition=0;
int nPositionOld=0;
BOOL (WINAPI *GetCPInfoExPtr) (UINT, DWORD, LPCPINFOEX);

LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK DummyWndProc(HWND, UINT, WPARAM, LPARAM);

void _WinMain()
{
  WNDCLASS wndclass={0};
  WNDCLASS dummyclass={0};
  HACCEL hAccel;
  MSG msg;
  BOOL msgstatus;
  HMODULE hKernel32=0;
  HMODULE hRTFLib=0;
  HMENU hLangMenu;
  OSVERSIONINFO osvi;
  HWND hWndFriend;
  char *pCmdLine;
  char *pName;
  int nMajor;
  int nMinor;
  int nRelease;
  int nBuild;
  int i;

  GetObject(GetStockObject(SYSTEM_FONT), sizeof(LOGFONT), &logfont);
  nAnsiCodePage=GetACP();
  nOemCodePage=GetOEMCP();
  nDefaultCodePage=nCurrentCodePage=nAnsiCodePage;
  wSystemLanguage=GetUserDefaultLangID();

  if (GetLocaleInfo(LOCALE_USER_DEFAULT, LOCALE_IMEASURE, buf, 16))
  {
    if (*buf == '0')
    {
      psdPage.rtMargin.left=1000;
      psdPage.rtMargin.right=1000;
      psdPage.rtMargin.top=1000;
      psdPage.rtMargin.bottom=1000;
      psdPage.Flags=PSD_INHUNDREDTHSOFMILLIMETERS;
    }
    else
    {
      psdPage.rtMargin.left=500;
      psdPage.rtMargin.right=500;
      psdPage.rtMargin.top=500;
      psdPage.rtMargin.bottom=500;
      psdPage.Flags=PSD_INTHOUSANDTHSOFINCHES;
    }
  }

  //Get options
  ReadOptionsFromRegistry();

  //Get Windows version
  osvi.dwOSVersionInfoSize=sizeof(OSVERSIONINFO);
  GetVersionEx(&osvi);
  if (osvi.dwPlatformId == VER_PLATFORM_WIN32_NT)
    bUnicode=TRUE;
  else
    bUnicode=FALSE;

  //Get standart WinMain info, because of own entry point.
  hInstance=GetModuleHandle(NULL);

  //Get command line
  lpCmdLine=pCmdLine=GetCommandLineParamsA();

  //Get command line arguments
  while (GetCommandLineArgA(pCmdLine, buf, &pCmdLine))
  {
    if (!lstrcmpi(buf, "/P"))
    {
      bGlobalPrint=TRUE;
      continue;
    }
    lstrcpy(szFileBuffer, buf);
    break;
  }

  //Is file already opened
  if (*szFileBuffer)
  {
    if (bSingleOpen && GetFullPathName(szFileBuffer, BUFFER_SIZE, buf, &pName))
    {
      if ((hWndFriend=FindWindow(APP_DUMMY_NAME, buf)) && (hWndFriend=GetParent(hWndFriend)))
      {
        SetForegroundWindow(hWndFriend);
        FreeMemorySearch();
        goto Quit;
      }
    }
  }

  //Get show window info
  lpStartupInfo.cb=sizeof(STARTUPINFO);
  GetStartupInfo(&lpStartupInfo);
  nCmdShow|=lpStartupInfo.wShowWindow;

  //Get program directory
  i=GetModuleFileName(NULL, szExeDir, MAX_PATH);
  while (i > 0 && szExeDir[i] != '\\') --i;
  szExeDir[i]='\0';

  //Get rich edit version
  GetFileVersion("riched20.dll", &nMajor, &nMinor, &nRelease, &nBuild);
  if (nMajor < 5 || (nMajor == 5 && nMinor < 30))
    bOldRichEdit=TRUE;
  else
    bOldRichEdit=FALSE;


  hKernel32=GetModuleHandle("kernel32.dll");
  GetCPInfoExPtr=(int(WINAPI *)(UINT, DWORD, LPCPINFOEX))GetProcAddress(hKernel32, "GetCPInfoExA");

  if (*szLangModule)
  {
    wsprintf(buf, "%s\\languages\\%s", szExeDir, szLangModule);

    if (!(hLangLib=LoadLibrary(buf)))
    {
      hLangLib=hInstance;
      API_LoadString(hLangLib, MSG_ERROR_LOADING_LANG_DLL, buf, BUFFER_SIZE);
      wsprintf(buf2, buf, szLangModule);
      MessageBox(NULL, buf2, APP_SHORT_TITLE, MB_OK|MB_ICONERROR);
    }
  }
  else hLangLib=hInstance;

  if (!(hRTFLib=LoadLibrary("riched20.dll")))
  {
    API_LoadString(hLangLib, MSG_ERROR_LOADING_RICHEDIT_DLL, buf, BUFFER_SIZE);
    MessageBox(NULL, buf, APP_SHORT_TITLE, MB_OK|MB_ICONERROR);
    goto Quit;
  }

  uiOpenOnStartMessage=RegisterWindowMessage("AkelPad Open-On-Start message");
  InitCommonControls();

  wndclass.style        =CS_HREDRAW|CS_VREDRAW;
  wndclass.lpfnWndProc  =WndProc;
  wndclass.cbClsExtra   =0;
  wndclass.cbWndExtra   =DLGWINDOWEXTRA;
  wndclass.hInstance    =hInstance;
  wndclass.hIcon        =API_LoadIcon(hLangLib, MAKEINTRESOURCE(IDI_ICON));
  wndclass.hCursor      =API_LoadCursor(hLangLib, IDC_ARROW);
  wndclass.hbrBackground=(HBRUSH)GetStockObject(HOLLOW_BRUSH);
  wndclass.lpszMenuName =MAKEINTRESOURCE(IDM_APPMENU);
  wndclass.lpszClassName=APP_FULL_TITLE;
  if (!RegisterClass(&wndclass)) goto Quit;

  dummyclass.style        =0;
  dummyclass.lpfnWndProc  =DummyWndProc;
  dummyclass.cbClsExtra   =0;
  dummyclass.cbWndExtra   =DLGWINDOWEXTRA;
  dummyclass.hInstance    =hInstance;
  dummyclass.hIcon        =LoadIcon(NULL, IDI_APPLICATION);
  dummyclass.hCursor      =LoadCursor(NULL, IDC_ARROW);
  dummyclass.hbrBackground=(HBRUSH)GetStockObject(HOLLOW_BRUSH);
  dummyclass.lpszMenuName =NULL;
  dummyclass.lpszClassName=APP_DUMMY_NAME;
  if (!RegisterClass(&dummyclass)) goto Quit;

  hLangMenu=API_LoadMenu(hLangLib, MAKEINTRESOURCE(IDM_APPMENU));
  hAccel=API_LoadAccelerators(hLangLib, MAKEINTRESOURCE(IDM_APPMENU));

  hMainWnd=CreateWindow(APP_FULL_TITLE,           // window class name
                    APP_SHORT_TITLE,              // window caption
                    WS_OVERLAPPEDWINDOW,          // window style
                    rcMainWindow.left,            // initial x position
                    rcMainWindow.top,             // initial y position
                    rcMainWindow.right,           // initial x size
                    rcMainWindow.bottom,          // initial y size
                    NULL,                         // parent window handle
                    hLangMenu,                    // window menu handle
                    hInstance,                    // program instance handle
                    NULL);                        // creation parameters
  if (!hMainWnd) goto Quit;

  hSyncWindow=CreateWindow(APP_DUMMY_NAME,        // window class name
                           "",                    // window caption
                           WS_POPUP,              // window style
                           CW_USEDEFAULT,         // initial x position
                           CW_USEDEFAULT,         // initial y position
                           CW_USEDEFAULT,         // initial x size
                           CW_USEDEFAULT,         // initial y size
                           hMainWnd,              // parent window handle
                           NULL,                  // window menu handle
                           hInstance,             // program instance handle
                           NULL);                 // creation parameters

  UpdateWindow(hMainWnd);

  while ((msgstatus=GetMessage(&msg, NULL, 0, 0)) && msgstatus != -1)
  {
    if (hDlgModeless == (HWND)NULL || !IsDialogMessage(hDlgModeless, &msg))
    {
      if (!TranslateAccelerator(hMainWnd, hAccel, &msg))
      {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
      }
    }
  }
  if (msgstatus == -1)
  {
    API_LoadString(hLangLib, MSG_ERROR_IN_MESSAGE_QUEUE, buf, BUFFER_SIZE);
    MessageBox(NULL, buf, APP_SHORT_TITLE, MB_OK|MB_ICONERROR);
  }

  Quit:
  if (hRTFLib) FreeLibrary(hRTFLib);
  if (hLangLib && hLangLib != hInstance) FreeLibrary(hLangLib);
  ExitProcess(0);
}

LRESULT CALLBACK WndProc(HWND hMainWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
  static HWND hWndEdit;
  static HMENU hPopup;
  static int iSBParts[]={110, 220, 250, 280, -1};
  LPARAM lMenuState;
  RECT rcRect;
  char *pName;
  int line;
  int column;

  if (message == uiOpenOnStartMessage)
  {
    ShowWindow(hMainWnd, nCmdShow);
    if (*szFileBuffer) OpenDocument(hWndEdit, szFileBuffer, -1, 0);
  }

  switch(message)
  {
    case WM_CREATE:
      hMenu=GetMenu(hMainWnd);
      hPopup=API_LoadMenu(hLangLib, MAKEINTRESOURCE(IDM_POPUP));
      hPopup=GetSubMenu(hPopup, 0);

      hStatus=CreateWindow(STATUSCLASSNAME,
                           "",
                           WS_CHILD|WS_VISIBLE|SBARS_SIZEGRIP,
                           0, 0, 0, 0,
                           hMainWnd,
                           (HMENU)ID_STATUS,
                           ((LPCREATESTRUCT)lParam)->hInstance,
                           NULL);

      SendMessage(hStatus, SB_SIMPLE, FALSE, 0);
      SendMessage(hStatus, SB_SETPARTS, 5, (LPARAM)&iSBParts);
      SendMessage(hStatus, SB_SETTEXT, 0, (LPARAM)"1:1");
      SendMessage(hStatus, SB_SETTEXT, 1, (LPARAM)"");
      SendMessage(hStatus, SB_SETTEXT, 2, (LPARAM)"Ins");
      SendMessage(hStatus, SB_SETTEXT, 3, (LPARAM)"Win");

      GetClientRect(hMainWnd, &rcRect);
      rcRect.right-=rcRect.left;
      rcRect.bottom-=rcRect.top;

      hWndEdit=CreateWindow("richedit20a",
                            NULL,
                            WS_CHILD|WS_VISIBLE|WS_HSCROLL|WS_VSCROLL|
                              ES_LEFT|ES_MULTILINE|ES_AUTOHSCROLL|ES_AUTOVSCROLL|
                              ES_DISABLENOSCROLL|ES_SUNKEN|ES_NOHIDESEL,
                            0,
                            0,
                            rcRect.right,
                            rcRect.bottom,
                            hMainWnd,
                            (HMENU)ID_EDIT,
                            ((LPCREATESTRUCT)lParam)->hInstance,
                            NULL);

      SendMessage(hWndEdit, EM_EXLIMITTEXT, 0, nMaxChars);

      InitEditor(hWndEdit);
      DragAcceptFiles(hMainWnd, TRUE);
      SetWindowText(hWndEdit, "");
      SetModify(FALSE);
      ShowWindow(hMainWnd, SW_HIDE);
      PostMessage(hMainWnd, uiOpenOnStartMessage, 0, 0);
      break;

    case WM_INITMENU:
      LanguageMenu(hWndEdit);
      lMenuState=SearchPath(NULL, "charmap.exe", NULL, BUFFER_SIZE, buf, &pName)?MF_ENABLED:MF_GRAYED;
      EnableMenuItem(hMenu, IDM_EDIT_INSERTCHAR, lMenuState);
    case WM_MENUSELECT:
    case WM_INITMENUPOPUP:
      //Check if any file is opened
      lMenuState=(*szCurrentFile)?MF_ENABLED:MF_GRAYED;
      EnableMenuItem(hMenu, IDM_FILE_REOPEN, lMenuState);
      EnableMenuItem(hMenu, IDM_FILE_REOPENAS_ANSI, lMenuState);
      EnableMenuItem(hMenu, IDM_FILE_REOPENAS_OEM, lMenuState);
      EnableMenuItem(hMenu, IDM_FILE_REOPENAS_UTF8, lMenuState);
      EnableMenuItem(hMenu, IDM_FILE_REOPENAS_KOIR, lMenuState);

      //Check if "Save" option should be enabled
      EnableMenuItem(hMenu, IDM_FILE_SAVE, (bModified || !*szCurrentFile)?MF_ENABLED:MF_GRAYED);

      //Check if the selection is empty
      lMenuState=(chrg.cpMin == chrg.cpMax)?MF_GRAYED:MF_ENABLED;
      EnableMenuItem(hMenu, IDM_EDIT_CUT, lMenuState);
      EnableMenuItem(hMenu, IDM_EDIT_COPY, lMenuState);
      EnableMenuItem(hMenu, IDM_EDIT_CLEAR, lMenuState);
      EnableMenuItem(hMenu, IDM_EDIT_UPPERCASE, lMenuState);
      EnableMenuItem(hMenu, IDM_EDIT_LOWERCASE, lMenuState);
      EnableMenuItem(hMenu, IDM_EDIT_SENTENCECASE, lMenuState);
      EnableMenuItem(hMenu, IDM_EDIT_TITLECASE, lMenuState);
      EnableMenuItem(hMenu, IDM_EDIT_INVERTCASE, lMenuState);

      lMenuState=(!DoEditInsertCharInSelection(hWndEdit, CHECK_STATE, 0))?MF_GRAYED:MF_ENABLED;
      EnableMenuItem(hMenu, IDM_EDIT_INSERT_TAB_MENU, lMenuState);
      EnableMenuItem(hMenu, IDM_EDIT_DELETE_TAB_MENU, lMenuState);
      EnableMenuItem(hMenu, IDM_EDIT_INSERT_SPACE_MENU, lMenuState);
      EnableMenuItem(hMenu, IDM_EDIT_DELETE_SPACE_MENU, lMenuState);

      lMenuState=(!DoEditDeleteTrailingWhitespaces(hWndEdit, CHECK_TRAILING_WHITESPACES))?MF_GRAYED:MF_ENABLED;
      EnableMenuItem(hMenu, IDM_EDIT_DELETE_TRAILING_WHITESPACES_MENU, lMenuState);

      //Check if paste, undo, redo is allowed
      EnableMenuItem(hMenu, IDM_EDIT_UNDO, SendMessage(hWndEdit, EM_CANUNDO, 0, 0)?MF_ENABLED:MF_GRAYED);
      EnableMenuItem(hMenu, IDM_EDIT_REDO, SendMessage(hWndEdit, EM_CANREDO, 0, 0)?MF_ENABLED:MF_GRAYED);
      EnableMenuItem(hMenu, IDM_EDIT_PASTE, SendMessage(hWndEdit, EM_CANPASTE, 0, 0)?MF_ENABLED:MF_GRAYED);

      //Set up Windows/Unix newline format selection
      CheckMenuItem(hMenu, IDM_EDIT_NEWLINE_UNIX, bUnixNewLine?MF_CHECKED:MF_UNCHECKED);
      CheckMenuItem(hMenu, IDM_EDIT_NEWLINE_WIN, bUnixNewLine?MF_UNCHECKED:MF_CHECKED);

      if (bOldRichEdit == TRUE)
      {
        EnableMenuItem(hMenu, IDM_VIEW_NUMBER_ARABIC, MF_GRAYED);
        EnableMenuItem(hMenu, IDM_VIEW_NUMBER_UCLETTER, MF_GRAYED);
        EnableMenuItem(hMenu, IDM_VIEW_NUMBER_UCROMAN, MF_GRAYED);
      }
      EnableMenuItem(hMenu, IDM_SETTINGS_EXEC, (*szCommand)?MF_ENABLED:MF_GRAYED);
      return 0;

    case WM_SETFOCUS:
      SetFocus(hWndEdit);
      return 0;

    case WM_GETMINMAXINFO:
      GetWindowRect(hMainWnd, &rcMainWindow);
      rcMainWindow.right-=rcMainWindow.left;
      rcMainWindow.bottom-=rcMainWindow.top;
      return 0;

    case WM_SIZE:
      SendMessage(hStatus, WM_SIZE, wParam, lParam);
      GetWindowRect(hStatus, &rcRect);

      if (bStatusBar == TRUE)
        MoveWindow(hWndEdit, 0, 0, LOWORD(lParam), HIWORD(lParam) - (rcRect.bottom - rcRect.top), TRUE);
      else
        MoveWindow(hWndEdit, 0, 0, LOWORD(lParam), HIWORD(lParam), TRUE);
      return 0;

    case WM_DROPFILES:
      if (SaveChanged(hWndEdit))
      {
        DragQueryFile((HDROP)wParam, 0, szFileBuffer, MAX_PATH);
        nPosition=nPositionOld;
        OpenDocument(hWndEdit, szFileBuffer, -1, 0);
      }
      return 0;

    case WM_CONTEXTMENU:
      if (wParam == (WPARAM)hWndEdit)
      {
        POINT pt;

        if (lParam == ((UINT)-1))
        {
          GetWindowRect((HWND)wParam, &rcRect);
          pt.x=rcRect.left;
          pt.y=rcRect.top;
        }
        else
        {
          pt.x=GET_X_LPARAM(lParam);
          pt.y=GET_Y_LPARAM(lParam);
        }

        //Check if the selection is empty
        EnableMenuItem(hPopup, IDM_EDIT_CUT, (chrg.cpMin == chrg.cpMax)?MF_GRAYED:MF_ENABLED);
        EnableMenuItem(hPopup, IDM_EDIT_COPY, (chrg.cpMin == chrg.cpMax)?MF_GRAYED:MF_ENABLED);
        EnableMenuItem(hPopup, IDM_EDIT_CLEAR, (chrg.cpMin == chrg.cpMax)?MF_GRAYED:MF_ENABLED);

        //Check if paste, undo, redo is allowed
        EnableMenuItem(hPopup, IDM_EDIT_UNDO, SendMessage(hWndEdit, EM_CANUNDO, 0, 0)?MF_ENABLED:MF_GRAYED);
        EnableMenuItem(hPopup, IDM_EDIT_REDO, SendMessage(hWndEdit, EM_CANREDO, 0, 0)?MF_ENABLED:MF_GRAYED);
        EnableMenuItem(hPopup, IDM_EDIT_PASTE, SendMessage(hWndEdit, EM_CANPASTE, 0, 0)?MF_ENABLED:MF_GRAYED);

        TrackPopupMenu(hPopup, 0, pt.x, pt.y, 0, hMainWnd, NULL);
      }
      return 0;

    case WM_COMMAND:
      if (LOWORD(wParam) == IDM_RECENT_FILES)
      {
        int nDead;

        RecentFilesRead();
        nDead=RecentFilesDeleteDead();
        RecentFilesSave();
        RecentFilesMenu(hWndEdit);

        API_LoadString(hLangLib, MSG_RECENTFILES_DELETED, buf, BUFFER_SIZE);
        wsprintf(buf2, buf, nDead);
        MessageBox(hMainWnd, buf2, APP_SHORT_TITLE, MB_OK|MB_ICONINFORMATION);

        return 0;
      }
      if (LOWORD(wParam) > IDM_RECENT_FILES && LOWORD(wParam) <= IDM_RECENT_FILES + nRecentFiles)
      {
        if (SaveChanged(hWndEdit))
        {
          lstrcpy(szFileBuffer, szRecentNames[LOWORD(wParam) - IDM_RECENT_FILES - 1]);
          OpenDocument(hWndEdit, szFileBuffer, -1, 0);
        }
        return 0;
      }
      if (LOWORD(wParam) >= IDM_LANGUAGE && LOWORD(wParam) <= IDM_LANGUAGE+nLangModules+1)
      {
        if (LOWORD(wParam) == IDM_LANGUAGE)
        {
          if (!*szLangModule) return 0;
          szLangModule[0]='\0';
        }
        else
        {
          GetMenuString(hMenu, LOWORD(wParam), buf, BUFFER_SIZE, MF_BYCOMMAND);
          wsprintf(buf2, "%s.dll", buf);
          if (!lstrcmpi(szLangModule, buf2)) return 0;
          lstrcpy(szLangModule, buf2);
        }
        API_LoadString(hLangLib, MSG_RESTART_LANGUAGE, buf, BUFFER_SIZE);
        MessageBox(hMainWnd, buf, APP_SHORT_TITLE, MB_OK|MB_ICONEXCLAMATION);
        return 0;
      }

      switch(LOWORD(wParam))
      {
        case ID_EDIT:
          switch(HIWORD(wParam))
          {
            case EN_CHANGE:
              SetModify(TRUE);
              break;
            case EN_MAXTEXT:
              //trying to reallocate
              API_LoadString(hLangLib, MSG_ERROR_LIMIT_REACHED, buf, BUFFER_SIZE);
              MessageBox(hMainWnd, buf, APP_SHORT_TITLE, MB_OK|MB_ICONERROR);
              nMaxChars+=nMcstep;
              SendMessage(hWndEdit, EM_EXLIMITTEXT, 0, nMaxChars);
              break;
            case EN_ERRSPACE:
              API_LoadString(hLangLib, MSG_ERROR_NOT_ENOUGH_MEMORY_FOR_RICHEDIT, buf, BUFFER_SIZE);
              MessageBox(hMainWnd, buf, APP_SHORT_TITLE, MB_OK|MB_ICONERROR);
              ExitProcess(1);
          }
          break;
        case IDM_FILE_NEW:
          DoFileNew(hWndEdit);
          break;
        case IDM_FILE_CREATENEW:
          SaveOptionsInRegistry(hMainWnd);
          DoFileNewWindow(hWndEdit);
          break;
        case IDM_FILE_OPEN:
          DoFileOpen(hWndEdit);
          break;
        case IDM_FILE_REOPEN:
          DoFileReopenAs(hWndEdit, nCurrentCodePage, bCurrentBOM);
          break;
        case IDM_FILE_REOPENAS_ANSI:
          DoFileReopenAs(hWndEdit, nAnsiCodePage, FALSE);
          break;
        case IDM_FILE_REOPENAS_OEM:
          DoFileReopenAs(hWndEdit, nOemCodePage, FALSE);
          break;
        case IDM_FILE_REOPENAS_UTF8:
          DoFileReopenAs(hWndEdit, CP_UNICODE_UTF8, -1);
          break;
        case IDM_FILE_REOPENAS_KOIR:
          DoFileReopenAs(hWndEdit, CP_KOI8_R, FALSE);
          break;
        case IDM_FILE_SAVE:
          DoFileSave(hWndEdit);
          break;
        case IDM_FILE_SAVEAS:
          DoFileSaveAs(hWndEdit);
          break;
        case IDM_FILE_PAGESETUP:
          DoFilePageSetup(hWndEdit);
          break;
        case IDM_FILE_PRINT:
          DoFilePrint(hWndEdit);
          break;
        case IDM_FILE_EXIT:
          DoFileExit(hWndEdit);
          break;

        case IDM_EDIT_UNDO:
          DoEditUndo(hWndEdit);
          break;
        case IDM_EDIT_REDO:
          DoEditRedo(hWndEdit);
          break;
        case IDM_EDIT_CUT:
          DoEditCut(hWndEdit);
          break;
        case IDM_EDIT_COPY:
          DoEditCopy(hWndEdit);
          break;
        case IDM_EDIT_PASTE:
          DoEditPaste(hWndEdit);
          break;
        case IDM_EDIT_PASTEANSI:
          DoEditPasteANSI(hWndEdit);
          break;
        case IDM_EDIT_CLEAR:
          DoEditClear(hWndEdit);
          break;
        case IDM_EDIT_SELECTALL:
          DoEditSelectAll(hWndEdit);
          break;
        case IDM_EDIT_INSERTCHAR:
          DoEditInsertChar(hWndEdit);
          break;
        case IDM_EDIT_INSERT_TAB_MENU:
        case IDM_EDIT_INSERT_TAB:
          DoEditInsertCharInSelection(hWndEdit, CHAR_INSERT, '\t');
          break;
        case IDM_EDIT_DELETE_TAB_MENU:
        case IDM_EDIT_DELETE_TAB:
          DoEditInsertCharInSelection(hWndEdit, CHAR_DELETE, '\t');
          break;
        case IDM_EDIT_INSERT_SPACE_MENU:
        case IDM_EDIT_INSERT_SPACE:
          DoEditInsertCharInSelection(hWndEdit, CHAR_INSERT, ' ');
          break;
        case IDM_EDIT_DELETE_SPACE_MENU:
        case IDM_EDIT_DELETE_SPACE:
          DoEditInsertCharInSelection(hWndEdit, CHAR_DELETE, ' ');
          break;
        case IDM_EDIT_DELETE_TRAILING_WHITESPACES_MENU:
        case IDM_EDIT_DELETE_TRAILING_WHITESPACES:
          DoEditDeleteTrailingWhitespaces(hWndEdit, DELETE_TRAILING_WHITESPACES);
          break;
        case IDM_EDIT_UPPERCASE:
          DoEditChangeCase(hWndEdit, UPPERCASE);
          break;
        case IDM_EDIT_LOWERCASE:
          DoEditChangeCase(hWndEdit, LOWERCASE);
          break;
        case IDM_EDIT_SENTENCECASE:
          DoEditChangeCase(hWndEdit, SENTENCECASE);
          break;
        case IDM_EDIT_TITLECASE:
          DoEditChangeCase(hWndEdit, TITLECASE);
          break;
        case IDM_EDIT_INVERTCASE:
          DoEditChangeCase(hWndEdit, INVERTCASE);
          break;
        case IDM_EDIT_NEWLINE_UNIX:
          if (!bUnixNewLine)
          {
            SetModify(TRUE);
            SetUnixNewLine(TRUE);
          }
          break;
        case IDM_EDIT_NEWLINE_WIN:
          if (bUnixNewLine)
          {
            SetModify(TRUE);
            SetUnixNewLine(FALSE);
          }
          break;

        case IDM_SEARCH_FIND:
          DoSearchFind(hWndEdit);
          break;
        case IDM_SEARCH_FINDNEXTDOWN:
          DoSearchFindNextDown(hWndEdit);
          break;
        case IDM_SEARCH_FINDNEXTUP:
          DoSearchFindNextUp(hWndEdit);
          break;
        case IDM_SEARCH_REPLACE:
          DoSearchReplace(hWndEdit);
          break;
        case IDM_SEARCH_GOTOLINE:
          DoSearchGoToLine(hWndEdit);
          break;

        case IDM_VIEW_FONT:
          DoViewFont(hWndEdit);
          break;
        case IDM_VIEW_TEXT_COLOR:
          DoViewTextColor(hWndEdit);
          break;
        case IDM_VIEW_BG_COLOR:
          DoViewBGColor(hWndEdit);
          break;
        case IDM_VIEW_DECREASE_FONT:
          DoViewFontSize(hWndEdit, DECREASE_FONT);
          break;
        case IDM_VIEW_INCREASE_FONT:
          DoViewFontSize(hWndEdit, INCREASE_FONT);
          break;
        case IDM_VIEW_ALIGN_CENTER:
          DoViewAlignment(hWndEdit, PFA_CENTER);
          break;
        case IDM_VIEW_ALIGN_RIGHT:
          DoViewAlignment(hWndEdit, PFA_RIGHT);
          break;
        case IDM_VIEW_ALIGN_LEFT:
          DoViewAlignment(hWndEdit, PFA_LEFT);
          break;
        case IDM_VIEW_NUMBER_ARABIC:
          DoViewNumbering(hWndEdit, PFN_ARABIC);
          break;
        case IDM_VIEW_NUMBER_UCLETTER:
          DoViewNumbering(hWndEdit, PFN_UCLETTER);
          break;
        case IDM_VIEW_NUMBER_UCROMAN:
          DoViewNumbering(hWndEdit, PFN_UCROMAN);
          break;
        case IDM_VIEW_NUMBER_BULLET:
          DoViewNumbering(hWndEdit, PFN_BULLET);
          break;
        case IDM_VIEW_NUMBER_NORMAL:
          DoViewNumbering(hWndEdit, 0);
          break;
        case IDM_VIEW_ONTOP:
          DoViewOnTop(hWndEdit, !bOnTop);
          break;
        case IDM_VIEW_WORDWRAP:
          DoViewWordWrap(hWndEdit, !bWordWrap);
          break;
        case IDM_VIEW_SHOW_STATUSBAR:
          DoViewShowStatusBar(hWndEdit, !bStatusBar);
          break;

        case IDM_SETTINGS_EXEC:
          DoSettingsExec(szCommand);
          break;
        case IDM_SETTINGS_SAVETIME:
          DoSettingsSaveTime(hWndEdit, !bSaveTime);
          break;
        case IDM_SETTINGS_SINGLEOPEN:
          DoSettingsSingleOpen(hWndEdit, !bSingleOpen);
          SaveOptionsInRegistry(hMainWnd);
          break;
        case IDM_SETTINGS_KEEPSPACE:
          DoSettingsKeepSpace(hWndEdit, !bKeepSpace);
          break;
        case IDM_SETTINGS_OPTIONS:
          DoSettingsOptions(hWndEdit);
          break;

        case IDM_HELP_ABOUT:
          DoHelpAbout(hWndEdit);
          break;

        case IDM_NONMENU_CHANGESIZE:
          ShowWindow(hMainWnd, (GetWindowLong(hMainWnd, GWL_STYLE) & WS_MAXIMIZE)?SW_RESTORE:SW_MAXIMIZE);
          break;
        case IDM_NONMENU_DELLINE:
          DoNonMenuDelLine(hWndEdit);
          break;
      }
      return 0;

    case WM_NOTIFY:
      //Some unmaintainable code is here
      if (wParam == ID_STATUS)
      {
        if (((NMHDR *)lParam)->code == NM_CLICK)
        {
          switch(((LPNMMOUSE)lParam)->dwItemSpec)
          {
            case 0:
              DoSearchGoToLine(hWndEdit);
              break;
            case 2:
              SendMessage(hWndEdit, WM_KEYDOWN, VK_INSERT, 0x00520001);
              SendMessage(hWndEdit, WM_KEYUP, VK_INSERT, 0xC0520001);
              break;
            case 3:
              SetUnixNewLine(!bUnixNewLine);
              SetModify(TRUE);
              break;
          }
        }
      }
      else if (wParam == ID_EDIT)
      {
        if (((NMHDR *)lParam)->code == EN_SELCHANGE)
        {
          CHARRANGE cr;
          int linebreaks=0;

          SendMessage(hWndEdit, EM_EXGETSEL, 0, (LPARAM)&cr);
          nPositionOld=nPosition;
          nPosition=(cr.cpMin == chrg.cpMin || cr.cpMin == chrg.cpMax)?cr.cpMax:cr.cpMin;
          chrg.cpMin=cr.cpMin;
          chrg.cpMax=cr.cpMax;

          line=SendMessage(hWndEdit, EM_EXLINEFROMCHAR, 0, nPosition)+1;
          column=SendMessage(hWndEdit, EM_LINEINDEX, line-1, 0); //column=index of first character in that string
          column=nPosition-column+1;

          if (chrg.cpMin == chrg.cpMax)
          {
            wsprintf(buf, "%u:%u", line, column);
          }
          else
          {
            if (!bUnixNewLine) linebreaks=SendMessage(hWndEdit, EM_EXLINEFROMCHAR, 0, chrg.cpMax)-SendMessage(hWndEdit, EM_EXLINEFROMCHAR, 0, chrg.cpMin);
            wsprintf(buf, "%u:%u, %u", line, column, chrg.cpMax-chrg.cpMin+linebreaks);
          }
          SendMessage(hStatus, SB_SETTEXT, 0, (LPARAM)buf);
        }
        else if (((NMHDR *)lParam)->code == EN_MSGFILTER)
        {
          if (((MSGFILTER *)lParam)->msg == WM_KEYDOWN && ((MSGFILTER *)lParam)->wParam == VK_RETURN && bKeepSpace)
          {
            TEXTRANGE txtrng;
            int minline;
            int minlineindex;
            int textsize;
            int a;
            char *pText;

            minline=SendMessage(hWndEdit, EM_LINEFROMCHAR, chrg.cpMin, 0);
            minlineindex=SendMessage(hWndEdit, EM_LINEINDEX, minline, 0);
            txtrng.chrg.cpMin=minlineindex;
            txtrng.chrg.cpMax=chrg.cpMin;
            textsize=txtrng.chrg.cpMax - txtrng.chrg.cpMin;

            if (textsize)
            {
              if (pText=(char *)API_HeapAlloc(GetProcessHeap(), 0, textsize + 2))
              {
                txtrng.lpstrText=pText + 1;
                SendMessage(hWndEdit, EM_GETTEXTRANGE, 0, (LPARAM)&txtrng);

                for (a=1, pText[0]='\n'; pText[a] == ' ' || pText[a] == '\t'; ++a);

                pText[a]='\0';
              }

              SendMessage(hWndEdit, EM_REPLACESEL, TRUE, (LPARAM)pText);
              HeapFree(GetProcessHeap(), 0, (LPVOID)pText);
              return -1;
            }
          }
          else if (((MSGFILTER *)lParam)->msg == WM_KEYDOWN && ((MSGFILTER *)lParam)->wParam == VK_INSERT)
          {
            if (GetKeyState(VK_SHIFT) >= 0 && GetKeyState(VK_CONTROL) >= 0)
            {
              SetInsertState(!bInsertstate);
            }
          }
          else if (((MSGFILTER *)lParam)->msg == WM_MOUSEWHEEL && LOWORD(((MSGFILTER *)lParam)->wParam) == MK_CONTROL)
          {
            if ((short)HIWORD(((MSGFILTER *)lParam)->wParam) < 0)
              DoViewFontSize(hWndEdit, DECREASE_FONT);
            else
              DoViewFontSize(hWndEdit, INCREASE_FONT);
            return -1;
          }
        }
      }
      return 0;

    case WM_CLOSE:
      DoFileExit(hWndEdit);
      return 0;

    case WM_DESTROY:
      if (hWndEdit) DestroyWindow(hWndEdit);
      SaveOptionsInRegistry(hMainWnd);
      FreeMemorySearch();
      FreeMemoryRecentFiles();
      PostQuitMessage(0);
      return 0;
  }

  return DefWindowProc(hMainWnd, message, wParam, lParam);
}

LRESULT CALLBACK DummyWndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
  if (message == WM_CREATE)
  {
    ShowWindow(hWnd, SW_HIDE);
    return 0;
  }

  return DefWindowProc(hWnd, message, wParam, lParam);
}
