#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <commdlg.h>
#include <shellapi.h>
#include <richedit.h>
#include <commctrl.h>
#include <wchar.h>
#include "akelpad.h"
#include "edit.h"

#define xatoi
#define hex2dec
#include "ConvFunc.h"

extern HINSTANCE hInstance;
extern HWND hMainWnd;
extern int nCmdShow;
extern HWND hDlgModeless;
extern HWND hSyncWindow;
extern HWND hStatus;
extern RECT rcMainWindow;
extern HMENU hMenu;
extern BOOL bOldRichEdit;
extern BOOL bUnicode;
extern BOOL bGlobalPrint;
extern char buf[];
extern char buf2[];
extern char szExeDir[];
extern char szLangModule[];
extern HMODULE hLangLib;
extern LANGID wSystemLanguage;
extern int nLangModules;
extern int nPosition;
extern CHARRANGE chrg;
extern BOOL (WINAPI *GetCPInfoExPtr) (UINT, DWORD, LPCPINFOEX);

unsigned char pcTranslateBuffer[TRANSLATE_BUFFER_SIZE];
BOOL bNewLineDetected=FALSE;
BOOL bInsertstate=TRUE;
BOOL bUnixNewLine=FALSE;
BOOL bModified=FALSE;
DWORD dwEditMargins=EDIT_MARGINS;
int nRecentFiles=RECENTFILES_AMOUNT;
char (*szRecentNames)[MAX_PATH]=NULL;
DWORD *szRecentPositions=NULL;
DWORD *szRecentCodepages=NULL;
OPENFILENAME ofn;
char szCurrentFile[MAX_PATH]="";
char szFileBuffer[MAX_PATH]="";
char szFilter[MAX_PATH];
LOGFONT logfont;
CHOOSEFONT cf;
CHOOSECOLOR cc;
COLORREF crBackground=RGB(0xFF, 0xFF, 0xFF);
COLORREF crFont=RGB(0x00, 0x00, 0x00);
COLORREF crCustColors[16]={0};
PAGESETUPDLG psdPage={0};
PRINTDLG pd={0};
DWORD ftflags=FR_DOWN;
BOOL bReplaceDlg;
int nReplaceCount;
wchar_t *wszSearch_orig=NULL;
wchar_t *wszReplace_orig=NULL;
wchar_t *wszSearch=NULL;
wchar_t *wszReplace=NULL;
BOOL bStatusBar=TRUE;
BOOL bOnTop=FALSE;
BOOL bWordWrap=FALSE;
BOOL bSaveTime=FALSE;
BOOL bSingleOpen=FALSE;
BOOL bKeepSpace=FALSE;
BOOL bFirstWordBreak=TRUE;
char szCommand[BUFFER_SIZE]="";
wchar_t wszDelimiters[DELIMITERS_SIZE]=WORD_DELIMITERSW;
BOOL bAutodetect=TRUE;
BOOL bSaveDlg;
int codepages[65536];
BOOL bEnumCodePages=FALSE;
BOOL bOfnBOM=FALSE;
BOOL bCurrentBOM=FALSE;
int nOfnCodePage;
int nCurrentCodePage;
int nDefaultCodePage;
int nAnsiCodePage;
int nOemCodePage;

typedef struct _PASTEDATA {
  unsigned char *pData;
  int nLength;
} PASTEDATA;

typedef struct _STREAMDATA {
  HANDLE hFile;
  int nCodePage;
  int nBytes;
  int nBytesRead;
} STREAMDATA;


//// Init function

void InitEditor(HWND hWndEdit)
{
  int nLangoptions;
  int i;

  API_LoadString(hLangLib, STR_FILE_FILTER, szFilter, MAX_PATH);
  for (i=0; szFilter[i]; ++i)
    if (szFilter[i] == '|') szFilter[i]='\0';
  szFilter[++i]='\0';

  ofn.lStructSize      =sizeof(OPENFILENAME);
  ofn.hwndOwner        =hWndEdit;
  ofn.hInstance        =hLangLib;
  ofn.lpstrFile        =(char *)&szFileBuffer;
  ofn.lpstrFilter      =szFilter;
  ofn.lpstrCustomFilter=NULL;
  ofn.nMaxCustFilter   =0;
  ofn.nFilterIndex     =2;
  ofn.nMaxFile         =MAX_PATH;
  ofn.lpstrFileTitle   =NULL;
  ofn.nMaxFileTitle    =0;
  ofn.lpstrInitialDir  =NULL;
  ofn.lpstrTitle       =NULL;
  ofn.nFileOffset      =0;
  ofn.nFileExtension   =0;
  ofn.lCustData        =0;
  ofn.Flags            =OFN_HIDEREADONLY|OFN_PATHMUSTEXIST|OFN_EXPLORER|OFN_ENABLEHOOK|OFN_ENABLETEMPLATE|OFN_ENABLESIZING;
  ofn.lpfnHook         =CodePageDlgProc;
  ofn.lpTemplateName   =MAKEINTRESOURCE(IDD_OFN);

  cf.lStructSize   =sizeof(CHOOSEFONT);
  cf.hwndOwner     =hWndEdit;
  cf.hDC           =NULL;
  cf.lpLogFont     =&logfont;
  cf.iPointSize    =0;
  cf.rgbColors     =0;
  cf.lCustData     =0;
  cf.lpfnHook      =NULL;
  cf.lpTemplateName=NULL;
  cf.hInstance     =NULL;
  cf.lpszStyle     =NULL;
  cf.nFontType     =0;
  cf.nSizeMin      =0;
  cf.nSizeMax      =0;
  cf.Flags         =CF_FORCEFONTEXIST|CF_INITTOLOGFONTSTRUCT|CF_SCREENFONTS;

  cc.lStructSize=sizeof(CHOOSECOLOR);
  cc.hwndOwner=hWndEdit;
  cc.hInstance=0;
  cc.lpCustColors=crCustColors;
  cc.Flags=CC_FULLOPEN|CC_RGBINIT;
  cc.lCustData=0;
  cc.lpfnHook=NULL;
  cc.lpTemplateName=NULL;

  psdPage.lStructSize=sizeof(PAGESETUPDLG);
  psdPage.hwndOwner=hWndEdit;
  psdPage.Flags|=PSD_MARGINS;

  pd.lStructSize=sizeof(PRINTDLG);
  pd.hwndOwner=hWndEdit;
  pd.Flags=PD_ALLPAGES|PD_NOPAGENUMS|PD_RETURNDC|PD_USEDEVMODECOPIESANDCOLLATE;
  pd.nCopies=1;

  nLangoptions=SendMessage(hWndEdit, EM_GETLANGOPTIONS, 0, 0);
  nLangoptions&=~IMF_AUTOFONT;
  nLangoptions&=~IMF_AUTOFONTSIZEADJUST;
  SendMessage(hWndEdit, EM_SETLANGOPTIONS, 0, nLangoptions);
  SendMessage(hWndEdit, EM_SETTEXTMODE, TM_RICHTEXT|TM_MULTILEVELUNDO|TM_MULTICODEPAGE, 0);
  SendMessage(hWndEdit, EM_SETWORDBREAKPROC, 0, (LPARAM)(EDITWORDBREAKPROC)EditWordBreakProc);
  SendMessage(hWndEdit, EM_SETEVENTMASK, 0, ENM_SELCHANGE|ENM_CHANGE|ENM_KEYEVENTS|ENM_MOUSEEVENTS);

  if (nRecentFiles)
  {
    if ((szRecentNames=(char (*)[MAX_PATH])API_HeapAlloc(GetProcessHeap(), 0, nRecentFiles * MAX_PATH)) &&
        (szRecentPositions=(DWORD *)API_HeapAlloc(GetProcessHeap(), 0, nRecentFiles * sizeof(DWORD))) &&
        (szRecentCodepages=(DWORD *)API_HeapAlloc(GetProcessHeap(), 0, nRecentFiles * sizeof(DWORD))))
    {
      RecentFilesZero();
      RecentFilesRead();
    }
    else PostQuitMessage(0);
  }
  RecentFilesMenu(hWndEdit);
  DoViewOnTop(hWndEdit, bOnTop);
  DoViewWordWrap(hWndEdit, bWordWrap);
  DoViewShowStatusBar(hWndEdit, bStatusBar);
  DoSettingsSaveTime(hWndEdit, bSaveTime);
  DoSettingsSingleOpen(hWndEdit, bSingleOpen);
  DoSettingsKeepSpace(hWndEdit, bKeepSpace);
  SendMessage(hWndEdit, EM_SETMARGINS, EC_LEFTMARGIN|EC_RIGHTMARGIN, dwEditMargins);
  SendMessage(hWndEdit, EM_SETBKGNDCOLOR, 0, crBackground);
  SetChosenFont(hWndEdit);
  SetChosenFontColor(hWndEdit);
  DisplayCodePage(nDefaultCodePage);
}


//// Menu functions

BOOL DoFileNew(HWND hWndEdit)
{
  if (!SaveChanged(hWndEdit)) return FALSE;

  if (nRecentFiles && *szCurrentFile)
  {
    RecentFilesZero();
    RecentFilesRead();
    RecentFilesUpdate(szCurrentFile, nPosition, MAKELONG(nCurrentCodePage, bCurrentBOM));
    RecentFilesSave();
  }

  szCurrentFile[0]='\0';
  SetUnixNewLine(FALSE);
  DisplayCodePage(nDefaultCodePage);
  HideCaret(NULL);
  SetWindowText(hWndEdit, "");
  ShowCaret(NULL);
  SetModify(FALSE);
  SetWindowText(hMainWnd, APP_SHORT_TITLE);

  return TRUE;
}

void DoFileNewWindow(HWND hWndEdit)
{
  STARTUPINFO si={0};
  PROCESS_INFORMATION pi={0};

  if (!GetModuleFileName(hInstance, buf, MAX_PATH)) return;

  si.cb=sizeof(STARTUPINFO);
  CreateProcess(buf, NULL, NULL, NULL, FALSE, 0, NULL, NULL, &si, &pi);
  CloseHandle(pi.hProcess);
  CloseHandle(pi.hThread);
}

BOOL DoFileOpen(HWND hWndEdit)
{
  if (!SaveChanged(hWndEdit)) return FALSE;

  bSaveDlg=FALSE;
  ofn.lpstrDefExt=NULL;

  if (GetOpenFileName(&ofn))
  {
    if (OpenDocument(hWndEdit, szFileBuffer, nOfnCodePage, bOfnBOM))
      return TRUE;
  }
  return FALSE;
}

void DoFileReopenAs(HWND hWndEdit, int nCodePage, int nBOM)
{
  if (!*szCurrentFile) return;
  else if (!bModified) OpenDocument(hWndEdit, szCurrentFile, nCodePage, nBOM);
  else
  {
    API_LoadString(hLangLib, MSG_FILE_WILL_BE_REOPENED, buf, BUFFER_SIZE);
    if (MessageBox(hMainWnd, buf, APP_SHORT_TITLE, MB_OKCANCEL|MB_ICONEXCLAMATION) == IDOK)
      OpenDocument(hWndEdit, szCurrentFile, nCodePage, nBOM);
  }
}

BOOL DoFileSave(HWND hWndEdit)
{
  if (!bModified && *szCurrentFile) return FALSE;
  if (!*szCurrentFile) return DoFileSaveAs(hWndEdit);
  SaveDocument(hWndEdit, szCurrentFile, nCurrentCodePage, bCurrentBOM);
  return TRUE;
}

BOOL DoFileSaveAs(HWND hWndEdit)
{
  bSaveDlg=TRUE;
  ofn.lpstrDefExt="txt";

  if (GetSaveFileName(&ofn))
  {
    if (SaveDocument(hWndEdit, szFileBuffer, nOfnCodePage, bOfnBOM))
      return TRUE;
  }
  return FALSE;
}

void DoFilePageSetup(HWND hWndEdit)
{
  PageSetupDlg(&psdPage);
}

void DoFilePrint(HWND hWndEdit)
{
  FORMATRANGE fr;
  DOCINFO di={0};
  int nextch;
  int width;
  int height;

  pd.hDevMode=psdPage.hDevMode;
  pd.hDevNames=psdPage.hDevNames;

  API_LoadString(hLangLib, STR_DOCNAME, buf, BUFFER_SIZE);
  di.cbSize=sizeof(DOCINFO);
  di.lpszDocName=(*szCurrentFile)?szCurrentFile:buf;

  if (!PrintDlg(&pd)) return;

  width=GetDeviceCaps(pd.hDC, HORZSIZE)*56;  //about 56 twips per millimeter
  height=GetDeviceCaps(pd.hDC, VERTSIZE)*56;

  fr.hdc=pd.hDC;
  fr.hdcTarget=pd.hDC;

  if (psdPage.Flags & PSD_INHUNDREDTHSOFMILLIMETERS)
  {
    fr.rc.left=psdPage.rtMargin.left*567/1000;
    fr.rc.top=psdPage.rtMargin.top*567/1000;
    fr.rc.right=width-psdPage.rtMargin.right*567/1000;
    fr.rc.bottom=height-psdPage.rtMargin.bottom*567/1000;
  }
  else
  {
    fr.rc.left=psdPage.rtMargin.left*144/100;
    fr.rc.top=psdPage.rtMargin.top*144/100;
    fr.rc.right=width-psdPage.rtMargin.right*144/100;
    fr.rc.bottom=height-psdPage.rtMargin.bottom*144/100;
  }
  fr.rcPage.left=0;
  fr.rcPage.top=0;
  fr.rcPage.right=width;
  fr.rcPage.bottom=height;

  if (pd.Flags & PD_PRINTTOFILE) di.lpszOutput="FILE:";

  if (StartDoc(pd.hDC, &di) <= 0)
  {
    API_LoadString(hLangLib, MSG_ERROR_PRINT, buf, BUFFER_SIZE);
    MessageBox(hMainWnd, buf, APP_SHORT_TITLE, MB_OK|MB_ICONERROR);
    return;
  }

  if (pd.Flags & PD_SELECTION)
  {
    SendMessage(hWndEdit, EM_EXGETSEL, 0, (LPARAM)&fr.chrg);
  }
  else
  {
    fr.chrg.cpMin=0;
    fr.chrg.cpMax=-1;
  }

  do
  {
    nextch=SendMessage(hWndEdit, EM_FORMATRANGE, FALSE, (LPARAM)&fr);
    if (nextch == fr.chrg.cpMin) break;
    fr.chrg.cpMin=nextch;
    StartPage(pd.hDC);
    if (!SendMessage(hWndEdit, EM_DISPLAYBAND, 0, (LPARAM)&fr.rc))
    {
      EndPage(pd.hDC);
      API_LoadString(hLangLib, MSG_ERROR_PRINT, buf, BUFFER_SIZE);
      MessageBox(hMainWnd, buf, APP_SHORT_TITLE, MB_OK|MB_ICONERROR);
      break;
    }
    EndPage(pd.hDC);
  }
  while (true);

  EndDoc(pd.hDC);
  DeleteDC(pd.hDC);
}

BOOL DoFileExit(HWND hWndEdit)
{
  if (!SaveChanged(hWndEdit)) return FALSE;

  if (nRecentFiles && *szCurrentFile)
  {
    RecentFilesZero();
    RecentFilesRead();
    RecentFilesUpdate(szCurrentFile, nPosition, MAKELONG(nCurrentCodePage, bCurrentBOM));
    RecentFilesSave();
  }

  DestroyWindow(hMainWnd);
  return TRUE;
}

void DoEditUndo(HWND hWndEdit)
{
  SendMessage(hWndEdit, EM_UNDO, 0, 0);
}

void DoEditRedo(HWND hWndEdit)
{
  SendMessage(hWndEdit, EM_REDO, 0, 0);
}

void DoEditCut(HWND hWndEdit)
{
  SendMessage(hWndEdit, WM_CUT, 0, 0);
}

void DoEditCopy(HWND hWndEdit)
{
  SendMessage(hWndEdit, WM_COPY, 0, 0);
}

void DoEditPaste(HWND hWndEdit)
{
  HGLOBAL hData;
  LPVOID pData;

  if (!OpenClipboard(hWndEdit))
    return;

  if ((hData=GetClipboardData(CF_UNICODETEXT)) && (pData=GlobalLock(hData)))
  {
    ReplaceSelW(hWndEdit, (wchar_t *)pData);
    GlobalUnlock(hData);
  }
  else if ((hData=GetClipboardData(CF_TEXT)) && (pData=GlobalLock(hData)))
  {
    ReplaceSelA(hWndEdit, (char *)pData);
    GlobalUnlock(hData);
  }
  CloseClipboard();
}

void DoEditPasteANSI(HWND hWndEdit)
{
  HGLOBAL hData;
  LPVOID pData;

  if (!OpenClipboard(hWndEdit))
    return;

  if ((hData=GetClipboardData(CF_TEXT)) && (pData=GlobalLock(hData)))
  {
    ReplaceSelA(hWndEdit, (char *)pData);
    GlobalUnlock(hData);
  }
  CloseClipboard();
}

void DoEditClear(HWND hWndEdit)
{
  SendMessage(hWndEdit, EM_REPLACESEL, TRUE, (LPARAM)"");
}

void DoEditSelectAll(HWND hWndEdit)
{
  SendMessage(hWndEdit, EM_SETSEL, 0, -1);
}

void DoEditInsertChar(HWND hWndEdit)
{
  ShellExecute(hMainWnd, "open", "charmap.exe", NULL, NULL, SW_SHOWDEFAULT);
}

BOOL DoEditInsertCharInSelection(HWND hWndEdit, int nAction, char ch)
{
  char *pText;
  TEXTRANGE txtrng;
  int layout;
  int a, b, c;
  int textsize;
  int tabs_number;
  int minline;
  int maxline;
  int minlineindex;
  int maxlineindex;
  int maxlinelength;
  BOOL cr_less_end=FALSE;

  if (chrg.cpMin != chrg.cpMax)
  {
    txtrng.chrg.cpMin=chrg.cpMin;
    txtrng.chrg.cpMax=chrg.cpMax;
    minline=SendMessage(hWndEdit, EM_LINEFROMCHAR, txtrng.chrg.cpMin, 0);
    maxline=SendMessage(hWndEdit, EM_LINEFROMCHAR, txtrng.chrg.cpMax, 0);
    minlineindex=SendMessage(hWndEdit, EM_LINEINDEX, minline, 0);
    maxlineindex=SendMessage(hWndEdit, EM_LINEINDEX, maxline, 0);
    maxlinelength=SendMessage(hWndEdit, EM_LINELENGTH, txtrng.chrg.cpMax, 0);

    if (minline != maxline || (minlineindex == txtrng.chrg.cpMin && !maxlinelength))
    {
      if (nAction == CHECK_STATE) return TRUE;
      if (maxlineindex != txtrng.chrg.cpMax)
      {
        if (maxlinelength) txtrng.chrg.cpMax=maxlineindex + maxlinelength + 1;
        else cr_less_end=TRUE;
      }
      else --maxline;

      txtrng.chrg.cpMin=minlineindex;
      SendMessage(hWndEdit, EM_EXSETSEL, 0, (LPARAM)&txtrng.chrg);

      if (nAction == CHAR_INSERT)
      {
        tabs_number=maxline - minline + 1;
        textsize=txtrng.chrg.cpMax - txtrng.chrg.cpMin + 1;

        if (pText=(char *)API_HeapAlloc(GetProcessHeap(), 0, textsize + tabs_number + 1))
        {
          layout=SetLayout();
          txtrng.lpstrText=pText + tabs_number;
          SendMessage(hWndEdit, EM_GETTEXTRANGE, 0, (LPARAM)&txtrng);
          RestoreLayout(layout);

          for (a=1, b=tabs_number, c=1, pText[0]=ch; c < tabs_number; pText[a++]=pText[b++])
            while (pText[b] == '\r' && c < tabs_number)
            {
              pText[a++]=pText[b++];
              pText[a++]=ch;
              ++c;
            }
        }
        else return FALSE;
      }
      else if (nAction == CHAR_DELETE)
      {
        textsize=txtrng.chrg.cpMax - txtrng.chrg.cpMin + 1;

        if (pText=(char *)API_HeapAlloc(GetProcessHeap(), 0, textsize + 2))
        {
          layout=SetLayout();
          txtrng.lpstrText=pText + 1;
          SendMessage(hWndEdit, EM_GETTEXTRANGE, 0, (LPARAM)&txtrng);
          RestoreLayout(layout);

          for (a=0, b=(pText[1] == ch)?2:1; b <= textsize; pText[a++]=pText[b++])
            while (pText[b] == '\r')
            {
              pText[a++]=pText[b++];
              if (pText[b] == ch) ++b;
            }
        }
        else return FALSE;
      }
      SendMessage(hWndEdit, EM_REPLACESEL, TRUE, (LPARAM)pText);
      if (cr_less_end) txtrng.chrg.cpMax=chrg.cpMax + 1;
      else txtrng.chrg.cpMax=chrg.cpMax;
      SendMessage(hWndEdit, EM_EXSETSEL, 0, (LPARAM)&txtrng.chrg);
      HeapFree(GetProcessHeap(), 0, (LPVOID)pText);
      return TRUE;
    }
  }
  if (nAction == CHECK_STATE) return FALSE;
  buf[0]=ch;
  buf[1]='\0';
  SendMessage(hWndEdit, EM_REPLACESEL, TRUE, (LPARAM)buf);
  return TRUE;
}

BOOL DoEditDeleteTrailingWhitespaces(HWND hWndEdit, int nAction)
{
  char *pText;
  TEXTRANGE txtrng;
  int layout;
  int a, b;
  int textsize;
  int maxline;
  int maxlineindex;
  int maxlinelength;
  BOOL cr_less_end=FALSE;

  if (chrg.cpMin != chrg.cpMax)
  {
    if (nAction == CHECK_TRAILING_WHITESPACES) return TRUE;
    txtrng.chrg.cpMin=chrg.cpMin;
    txtrng.chrg.cpMax=chrg.cpMax;
    maxline=SendMessage(hWndEdit, EM_LINEFROMCHAR, txtrng.chrg.cpMax, 0);
    maxlineindex=SendMessage(hWndEdit, EM_LINEINDEX, maxline, 0);
    maxlinelength=SendMessage(hWndEdit, EM_LINELENGTH, txtrng.chrg.cpMax, 0);

    if (nAction == DELETE_TRAILING_WHITESPACES)
    {
      if (maxlineindex != txtrng.chrg.cpMax && !maxlinelength)
        cr_less_end=TRUE;
      textsize=txtrng.chrg.cpMax - txtrng.chrg.cpMin + 1;

      if (pText=(char *)API_HeapAlloc(GetProcessHeap(), 0, textsize + 2))
      {
        layout=SetLayout();
        txtrng.lpstrText=pText + 1;
        SendMessage(hWndEdit, EM_GETTEXTRANGE, 0, (LPARAM)&txtrng);
        RestoreLayout(layout);

        for (a=0, b=1; b <= textsize; pText[a++]=pText[b++])
          while (pText[b] == '\r' || pText[b] == '\0')
          {
            do --a;
            while (a >= 0 && (pText[a] == '\t' || pText[a] == ' '));

            ++a;
            pText[a++]=pText[b++];
          }
      }
      else return FALSE;

      SendMessage(hWndEdit, EM_REPLACESEL, TRUE, (LPARAM)pText);
      if (cr_less_end) txtrng.chrg.cpMax=chrg.cpMax + 1;
      else txtrng.chrg.cpMax=chrg.cpMax;
      SendMessage(hWndEdit, EM_EXSETSEL, 0, (LPARAM)&txtrng.chrg);
      HeapFree(GetProcessHeap(), 0, (LPVOID)pText);
      return TRUE;
    }
  }
  if (nAction == CHECK_TRAILING_WHITESPACES) return FALSE;
  SendMessage(hWndEdit, WM_KEYDOWN, VK_BACK, 0);
  return TRUE;
}

void DoEditChangeCase(HWND hWndEdit, int nCase)
{
  TEXTRANGE txtrng;
  int textsize;
  char *pStart;
  char *pEnd;
  int layout;

  if (chrg.cpMin != chrg.cpMax)
  {
    txtrng.chrg.cpMin=chrg.cpMin;
    txtrng.chrg.cpMax=chrg.cpMax;
    textsize=txtrng.chrg.cpMax - txtrng.chrg.cpMin;

    pStart=txtrng.lpstrText=(char *)API_HeapAlloc(GetProcessHeap(), 0, textsize + 1);
    if (!txtrng.lpstrText) return;
    layout=SetLayout();

    pEnd=pStart + textsize;
    SendMessage(hWndEdit, EM_GETTEXTRANGE, 0, (LPARAM)&txtrng);

    switch(nCase)
    {
      case UPPERCASE:
        CharUpperBuff(txtrng.lpstrText, textsize);
        break;

      case LOWERCASE:
        CharLowerBuff(txtrng.lpstrText, textsize);
        break;

      case SENTENCECASE:
        while (pStart < pEnd)
        {
          while (pStart < pEnd && (*pStart == ' ' || *pStart == '\t' || *pStart == '\r' || strchr(SENTENCE_SELIMITERS, *pStart)))
            ++pStart;

          if (pStart < pEnd) *pStart++=(char)CharUpper((char*)(unsigned)(unsigned char)*pStart);

          while (pStart < pEnd && !strchr(SENTENCE_SELIMITERS, *pStart))
            *pStart++=(char)CharLower((char*)(unsigned)(unsigned char)*pStart);
        }
        break;

      case TITLECASE:
        while (pStart < pEnd)
        {
          while (pStart < pEnd && strchr(TITLE_DELIMITERS, *pStart))
            ++pStart;

          if (pStart < pEnd) *pStart++=(char)CharUpper((char*)(unsigned)(unsigned char)*pStart);

          while (pStart < pEnd && !strchr(TITLE_DELIMITERS, *pStart))
            *pStart++=(char)CharLower((char*)(unsigned)(unsigned char)*pStart);
        }
        break;

      case INVERTCASE:
        while (pStart < pEnd)
        {
          if (IsCharLower(*pStart))
            *pStart++=(char)CharUpper((char*)(unsigned)(unsigned char)*pStart);
          else
            *pStart++=(char)CharLower((char*)(unsigned)(unsigned char)*pStart);
        }
        break;
    }
    SendMessage(hWndEdit, EM_REPLACESEL, TRUE, (LPARAM)txtrng.lpstrText);
    SendMessage(hWndEdit, EM_EXSETSEL, 0, (LPARAM)&txtrng.chrg);
    HeapFree(GetProcessHeap(), 0, (LPVOID)txtrng.lpstrText);
    RestoreLayout(layout);
  }
}

void DoSearchFind(HWND hWndEdit)
{
  if (hDlgModeless == NULL)
  {
    bReplaceDlg=FALSE;
    if (ftflags & FR_SELECTION) ftflags&=~FR_SELECTION;

    if (bUnicode && (hDlgModeless=API_CreateDialogParamW(hLangLib, MAKEINTRESOURCEW(IDD_FIND), hMainWnd, (DLGPROC)FindAndReplaceDlgProcW, (LPARAM)hWndEdit)))
    {
      ShowWindow(hDlgModeless, SW_SHOW);
    }
    else if (!bUnicode && (hDlgModeless=API_CreateDialogParamA(hLangLib, MAKEINTRESOURCE(IDD_FIND), hMainWnd, (DLGPROC)FindAndReplaceDlgProcW, (LPARAM)hWndEdit)))
    {
      ShowWindow(hDlgModeless, SW_SHOW);
    }
  }
}

void DoSearchFindNextDown(HWND hWndEdit)
{
  DWORD tmpflags=ftflags;

  if (wszSearch)
  {
    ftflags&=~FR_UP&~FR_BEGINNING&~FR_SELECTION;
    ftflags|=FR_DOWN;

    FindTextW(hWndEdit);

    ftflags=tmpflags;
  }
  else DoSearchFind(hWndEdit);
}

void DoSearchFindNextUp(HWND hWndEdit)
{
  DWORD tmpflags=ftflags;

  if (wszSearch)
  {
    ftflags&=~FR_DOWN&~FR_BEGINNING&~FR_SELECTION;
    ftflags|=FR_UP;

    FindTextW(hWndEdit);

    ftflags=tmpflags;
  }
  else DoSearchFind(hWndEdit);
}

void DoSearchReplace(HWND hWndEdit)
{
  if (hDlgModeless == NULL)
  {
    bReplaceDlg=TRUE;

    if (bUnicode && (hDlgModeless=API_CreateDialogParamW(hLangLib, MAKEINTRESOURCEW(IDD_REPLACE), hMainWnd, (DLGPROC)FindAndReplaceDlgProcW, (LPARAM)hWndEdit)))
    {
      ShowWindow(hDlgModeless, SW_SHOW);
    }
    else if (!bUnicode && (hDlgModeless=API_CreateDialogParamA(hLangLib, MAKEINTRESOURCE(IDD_REPLACE), hMainWnd, (DLGPROC)FindAndReplaceDlgProcW, (LPARAM)hWndEdit)))
    {
      ShowWindow(hDlgModeless, SW_SHOW);
    }
  }
}

void DoSearchGoToLine(HWND hWndEdit)
{
  if (hDlgModeless == NULL)
  {
    if (bUnicode && (hDlgModeless=API_CreateDialogParamW(hLangLib, MAKEINTRESOURCEW(IDD_GOTOLINE), hMainWnd, (DLGPROC)GoToLineDlgProc, (LPARAM)hWndEdit)))
    {
      ShowWindow(hDlgModeless, SW_SHOW);
    }
    else  if (!bUnicode && (hDlgModeless=API_CreateDialogParamA(hLangLib, MAKEINTRESOURCE(IDD_GOTOLINE), hMainWnd, (DLGPROC)GoToLineDlgProc, (LPARAM)hWndEdit)))
    {
      ShowWindow(hDlgModeless, SW_SHOW);
    }
  }
}

void DoViewFont(HWND hWndEdit)
{
  LOGFONT tmp;

  memcpy(&tmp, &logfont, sizeof(LOGFONT));

  if (ChooseFont(&cf))
  {
    SetChosenFont(hWndEdit);
  }
  else memcpy(&logfont, &tmp, sizeof(LOGFONT));
}

void DoViewTextColor(HWND hWndEdit)
{
  COLORREF tmp=cc.rgbResult=crFont;

  if (ChooseColor(&cc))
  {
    crFont=cc.rgbResult;
    SetChosenFontColor(hWndEdit);
  }
  else crFont=tmp;
}


void DoViewBGColor(HWND hWndEdit)
{
  COLORREF tmp=cc.rgbResult=crBackground;

  if (ChooseColor(&cc))
  {
    crBackground=cc.rgbResult;
    SendMessage(hWndEdit, EM_SETBKGNDCOLOR, 0, crBackground);
  }
  else crBackground=tmp;
}

void DoViewFontSize(HWND hWndEdit, int nAction)
{
  if (nAction == DECREASE_FONT)
  {
    if (logfont.lfHeight >= 0)
      logfont.lfHeight-=1;
    else
      logfont.lfHeight+=1;
    SetChosenFontSize(hWndEdit);
  }
  else if (nAction == INCREASE_FONT)
  {
    if (logfont.lfHeight >= 0)
      logfont.lfHeight+=1;
    else
      logfont.lfHeight-=1;
    SetChosenFontSize(hWndEdit);
  }
}

void DoViewAlignment(HWND hWndEdit, WORD wAlignment)
{
  PARAFORMAT2 pf;

  pf.cbSize=sizeof(PARAFORMAT2);
  pf.dwMask=PFM_ALIGNMENT;
  pf.wAlignment=wAlignment;
  SendMessage(hWndEdit, EM_SETPARAFORMAT, 0, (LPARAM)&pf);
}

void DoViewNumbering(HWND hWndEdit, WORD wNumbering)
{
  PARAFORMAT2 pf;

  pf.cbSize=sizeof(PARAFORMAT2);
  pf.dwMask=PFM_NUMBERING|PFM_NUMBERINGSTART|PFM_NUMBERINGSTYLE;
  pf.wNumbering=wNumbering;
  pf.wNumberingStart=1;
  pf.wNumberingStyle=PFNS_PAREN;
  SendMessage(hWndEdit, EM_SETPARAFORMAT, 0, (LPARAM)&pf);
}

void DoViewOnTop(HWND hWndEdit, BOOL bBool)
{
  CheckMenuItem(hMenu, IDM_VIEW_ONTOP, bBool?MF_CHECKED:MF_UNCHECKED);
  if (bOnTop == bBool) return;

  if (bOnTop=bBool)
  {
    SetWindowPos(hMainWnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE|SWP_NOSIZE|SWP_NOACTIVATE);
  }
  else
  {
    SetWindowPos(hMainWnd, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOMOVE|SWP_NOSIZE|SWP_NOACTIVATE);
  }
}

void DoViewWordWrap(HWND hWndEdit, BOOL bBool)
{
  NMHDR nmhdr;
  int nAfterLine;
  int nBeforeLine;
  int nBeforeLineIndex;

  CheckMenuItem(hMenu, IDM_VIEW_WORDWRAP, bBool?MF_CHECKED:MF_UNCHECKED);
  if (bWordWrap == bBool) return;
  nBeforeLine=SendMessage(hWndEdit, EM_GETFIRSTVISIBLELINE, 0, 0);
  nBeforeLineIndex=SendMessage(hWndEdit, EM_LINEINDEX, nBeforeLine, 0);

  if (bWordWrap=bBool)
  {
    SendMessage(hWndEdit, EM_SETTARGETDEVICE, NULL, 0);
  }
  else
  {
    SendMessage(hWndEdit, EM_SETTARGETDEVICE, NULL, -1);
  }
  nmhdr.hwndFrom=hWndEdit;
  nmhdr.idFrom=ID_EDIT;
  nmhdr.code=EN_SELCHANGE;
  SendMessage(hMainWnd, WM_NOTIFY, ID_EDIT, (LPARAM)&nmhdr);

  nAfterLine=SendMessage(hWndEdit, EM_GETFIRSTVISIBLELINE, 0, 0);
  nBeforeLine=SendMessage(hWndEdit, EM_LINEFROMCHAR, nBeforeLineIndex, 0);
  SendMessage(hWndEdit, EM_LINESCROLL, 0, nBeforeLine - nAfterLine);
}

void DoViewShowStatusBar(HWND hWndEdit, BOOL bBool)
{
  RECT rcEdit;
  RECT rcStatus;

  CheckMenuItem(hMenu, IDM_VIEW_SHOW_STATUSBAR, bBool?MF_CHECKED:MF_UNCHECKED);
  if (bStatusBar == bBool) return;
  GetWindowRect(hWndEdit, &rcEdit);
  GetWindowRect(hStatus, &rcStatus);

  if (bStatusBar=bBool)
  {
    ShowWindow(hStatus, SW_SHOW);
    MoveWindow(hWndEdit, 0, 0, rcEdit.right - rcEdit.left, (rcEdit.bottom - rcEdit.top) - (rcStatus.bottom - rcStatus.top), TRUE);
  }
  else
  {
    ShowWindow(hStatus, SW_HIDE);
    MoveWindow(hWndEdit, 0, 0, rcEdit.right - rcEdit.left, (rcEdit.bottom - rcEdit.top) + (rcStatus.bottom - rcStatus.top), TRUE);
  }
}

void DoSettingsExec(char *pCommand)
{
  STARTUPINFO si={0};
  PROCESS_INFORMATION pi={0};
  char *szResult;
  int nLen;
  int i;

  nLen=ParseExecCommand(pCommand, NULL, 0) + 1;

  if (szResult=(char *)API_HeapAlloc(GetProcessHeap(), 0, nLen + 1))
  {
    ParseExecCommand(pCommand, szResult, nLen);
    si.cb=sizeof(STARTUPINFO);
    if (i=CreateProcess(NULL, szResult, NULL, NULL, FALSE, 0, NULL, NULL, &si, &pi))
    {
      CloseHandle(pi.hProcess);
      CloseHandle(pi.hThread);
    }
    else
    {
      API_LoadString(hLangLib, MSG_ERROR_RUN, buf, BUFFER_SIZE);
      MessageBox(hMainWnd, buf, APP_SHORT_TITLE, MB_OK|MB_ICONEXCLAMATION);
    }
    HeapFree(GetProcessHeap(), 0, (LPVOID)szResult);
  }
}

void DoSettingsSaveTime(HWND hWndEdit, BOOL bBool)
{
  CheckMenuItem(hMenu, IDM_SETTINGS_SAVETIME, bBool?MF_CHECKED:MF_UNCHECKED);
  if (bSaveTime == bBool) return;
  bSaveTime=bBool;
}

void DoSettingsSingleOpen(HWND hWndEdit, BOOL bBool)
{
  CheckMenuItem(hMenu, IDM_SETTINGS_SINGLEOPEN, bBool?MF_CHECKED:MF_UNCHECKED);
  if (bSingleOpen == bBool) return;
  bSingleOpen=bBool;
}

void DoSettingsKeepSpace(HWND hWndEdit, BOOL bBool)
{
  CheckMenuItem(hMenu, IDM_SETTINGS_KEEPSPACE, bBool?MF_CHECKED:MF_UNCHECKED);
  if (bKeepSpace == bBool) return;
  bKeepSpace=bBool;
}

void DoSettingsOptions(HWND hWndEdit)
{
  DialogBox(hLangLib, MAKEINTRESOURCE(IDD_OPTIONS), hMainWnd, (DLGPROC)OptionsDlgProc);
}

void DoHelpAbout(HWND hWndEdit)
{
  DialogBox(hLangLib, MAKEINTRESOURCE(IDD_ABOUT), hMainWnd, (DLGPROC)AboutDlgProc);
}

void DoNonMenuDelLine(HWND hWndEdit)
{
  int line;
  CHARRANGE selrng;

  line=SendMessage(hWndEdit, EM_LINEFROMCHAR, nPosition, 0);
  selrng.cpMin=SendMessage(hWndEdit, EM_LINEINDEX, line, 0);
  selrng.cpMax=selrng.cpMin + SendMessage(hWndEdit, EM_LINELENGTH, nPosition, 0) + 1;

  SendMessage(hWndEdit, EM_EXSETSEL, 0, (LPARAM)&selrng);
  SendMessage(hWndEdit, EM_REPLACESEL, TRUE, (LPARAM)"");
}


//// Read/Save options

BOOL ReadOptionsFromRegistry()
{
  HKEY hKey;
  DWORD dwType;
  DWORD dwSize;

  if (RegOpenKeyEx(HKEY_CURRENT_USER, "Software\\Akelsoft\\AkelPad", 0, KEY_READ, &hKey) != ERROR_SUCCESS)
    return FALSE;

  dwSize=MAX_PATH;
  RegQueryValueEx(hKey, "LanguageModule", NULL, &dwType, (LPBYTE)&szLangModule, &dwSize);

  dwSize=sizeof(BOOL);
  RegQueryValueEx(hKey, "OnTop", NULL, &dwType, (LPBYTE)&bOnTop, &dwSize);

  dwSize=sizeof(BOOL);
  RegQueryValueEx(hKey, "WordWrap", NULL, &dwType, (LPBYTE)&bWordWrap, &dwSize);

  dwSize=sizeof(BOOL);
  RegQueryValueEx(hKey, "StatusBar", NULL, &dwType, (LPBYTE)&bStatusBar, &dwSize);

  dwSize=sizeof(BOOL);
  RegQueryValueEx(hKey, "SaveTime", NULL, &dwType, (LPBYTE)&bSaveTime, &dwSize);

  dwSize=sizeof(BOOL);
  RegQueryValueEx(hKey, "SingleOpen", NULL, &dwType, (LPBYTE)&bSingleOpen, &dwSize);

  dwSize=sizeof(BOOL);
  RegQueryValueEx(hKey, "KeepSpace", NULL, &dwType, (LPBYTE)&bKeepSpace, &dwSize);

  dwSize=sizeof(LOGFONT);
  RegQueryValueEx(hKey, "Font", NULL, &dwType, (LPBYTE)&logfont, &dwSize);

  dwSize=sizeof(COLORREF);
  RegQueryValueEx(hKey, "TextColor", NULL, &dwType, (LPBYTE)&crFont, &dwSize);

  dwSize=sizeof(COLORREF);
  RegQueryValueEx(hKey, "Background", NULL, &dwType, (LPBYTE)&crBackground, &dwSize);

  dwSize=sizeof(RECT);
  RegQueryValueEx(hKey, "MarginsPrint", NULL, &dwType, (LPBYTE)&psdPage.rtMargin, &dwSize);

  dwSize=sizeof(DWORD);
  RegQueryValueEx(hKey, "MarginsEdit", NULL, &dwType, (LPBYTE)&dwEditMargins, &dwSize);

  dwSize=sizeof(int);
  RegQueryValueEx(hKey, "DefaultCodepage", NULL, &dwType, (LPBYTE)&nDefaultCodePage, &dwSize);

  dwSize=sizeof(int);
  RegQueryValueEx(hKey, "RecentFiles", NULL, &dwType, (LPBYTE)&nRecentFiles, &dwSize);

  dwSize=DELIMITERS_SIZE * sizeof(wchar_t);
  RegQueryValueEx(hKey, "WordDelimiters", NULL, &dwType, (LPBYTE)&wszDelimiters, &dwSize);

  dwSize=BUFFER_SIZE;
  RegQueryValueEx(hKey, "ExecuteCommand", NULL, &dwType, (LPBYTE)&szCommand, &dwSize);

  dwSize=sizeof(DWORD);
  RegQueryValueEx(hKey, "SearchOptions", NULL, &dwType, (LPBYTE)&ftflags, &dwSize);

  dwSize=sizeof(DWORD);
  RegQueryValueEx(hKey, "WindowStyle", NULL, &dwType, (LPBYTE)&nCmdShow, &dwSize);

  dwSize=sizeof(RECT);
  RegQueryValueEx(hKey, "WindowPosition", NULL, &dwType, (LPBYTE)&rcMainWindow, &dwSize);

  if (RegQueryValueEx(hKey, "SearchString", NULL, &dwType, NULL, &dwSize) == ERROR_SUCCESS)
  {
    if (dwSize > 0 && dwType == REG_BINARY)
    {
      if (wszSearch_orig=wszSearch=(wchar_t *)API_HeapAlloc(GetProcessHeap(), 0, dwSize + 2))
      {
        RegQueryValueEx(hKey, "SearchString", NULL, &dwType, (LPBYTE)wszSearch_orig, &dwSize);

        if (ftflags & FR_ESCAPESEQ)
        {
          if (wszSearch=(wchar_t *)API_HeapAlloc(GetProcessHeap(), 0, dwSize + 2))
          {
            EscapeStringToEscapeDataW(wszSearch_orig, wszSearch);
          }
        }
      }
    }
  }

  if (RegQueryValueEx(hKey, "ReplaceString", NULL, &dwType, NULL, &dwSize) == ERROR_SUCCESS)
  {
    if (dwSize > 0 && dwType == REG_BINARY)
    {
      if (wszReplace_orig=wszReplace=(wchar_t *)API_HeapAlloc(GetProcessHeap(), 0, dwSize + 2))
      {
        RegQueryValueEx(hKey, "ReplaceString", NULL, &dwType, (LPBYTE)wszReplace_orig, &dwSize);

        if (ftflags & FR_ESCAPESEQ)
        {
          if (wszReplace=(wchar_t *)API_HeapAlloc(GetProcessHeap(), 0, dwSize + 2))
          {
            EscapeStringToEscapeDataW(wszReplace_orig, wszReplace);
          }
        }
      }
    }
  }

  RegCloseKey(hKey);
  return TRUE;
}

BOOL SaveOptionsInRegistry(HWND hWnd)
{
  HKEY hKey;
  DWORD dwDisp;
  int nMaximize=(GetWindowLong(hWnd, GWL_STYLE) & WS_MAXIMIZE)?SW_MAXIMIZE:0;

  if (!nMaximize)
  {
    GetWindowRect(hMainWnd, &rcMainWindow);
    rcMainWindow.right-=rcMainWindow.left;
    rcMainWindow.bottom-=rcMainWindow.top;
  }

  if (RegCreateKeyEx(HKEY_CURRENT_USER, "Software\\Akelsoft\\AkelPad", 0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hKey, &dwDisp) != ERROR_SUCCESS)
    return FALSE;

  if (RegSetValueEx(hKey, "LanguageModule", 0, REG_SZ, (LPBYTE)szLangModule, lstrlen(szLangModule) + 1) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueEx(hKey, "SearchString", 0, REG_BINARY, (LPBYTE)(wszSearch_orig?wszSearch_orig:L""), wszSearch_orig?API_lstrlenW(wszSearch_orig) * sizeof(wchar_t) + 2:2) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueEx(hKey, "ReplaceString", 0, REG_BINARY, (LPBYTE)(wszReplace_orig?wszReplace_orig:L""), wszReplace_orig?API_lstrlenW(wszReplace_orig) * sizeof(wchar_t) + 2:2) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueEx(hKey, "SearchOptions", 0, REG_DWORD, (LPBYTE)&ftflags, sizeof(DWORD)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueEx(hKey, "SaveTime", 0, REG_DWORD, (LPBYTE)&bSaveTime, sizeof(BOOL)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueEx(hKey, "SingleOpen", 0, REG_DWORD, (LPBYTE)&bSingleOpen, sizeof(BOOL)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueEx(hKey, "StatusBar", 0, REG_DWORD, (LPBYTE)&bStatusBar, sizeof(BOOL)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueEx(hKey, "OnTop", 0, REG_DWORD, (LPBYTE)&bOnTop, sizeof(BOOL)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueEx(hKey, "WordWrap", 0, REG_DWORD, (LPBYTE)&bWordWrap, sizeof(BOOL)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueEx(hKey, "KeepSpace", 0, REG_DWORD, (LPBYTE)&bKeepSpace, sizeof(BOOL)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueEx(hKey, "DefaultCodepage", 0, REG_DWORD, (LPBYTE)&nDefaultCodePage, sizeof(int)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueEx(hKey, "RecentFiles", 0, REG_DWORD, (LPBYTE)&nRecentFiles, sizeof(DWORD)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueEx(hKey, "WordDelimiters", 0, REG_BINARY, (LPBYTE)&wszDelimiters, lstrlenW(wszDelimiters) * sizeof(wchar_t) + 2) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueEx(hKey, "ExecuteCommand", 0, REG_SZ, (LPBYTE)&szCommand, lstrlen(szCommand) + 1) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueEx(hKey, "MarginsEdit", 0, REG_DWORD, (LPBYTE)&dwEditMargins, sizeof(DWORD)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueEx(hKey, "MarginsPrint", 0, REG_BINARY, (LPBYTE)&psdPage.rtMargin, sizeof(RECT)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueEx(hKey, "Font", 0, REG_BINARY, (LPBYTE)&logfont, sizeof(LOGFONT)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueEx(hKey, "TextColor", 0, REG_DWORD, (LPBYTE)&crFont, sizeof(COLORREF)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueEx(hKey, "Background", 0, REG_DWORD, (LPBYTE)&crBackground, sizeof(COLORREF)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueEx(hKey, "WindowStyle", 0, REG_DWORD, (LPBYTE)&nMaximize, sizeof(DWORD)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueEx(hKey, "WindowPosition", 0, REG_BINARY, (LPBYTE)&rcMainWindow, sizeof(RECT)) != ERROR_SUCCESS)
    goto Error;

  RegCloseKey(hKey);
  return TRUE;

  Error:
  RegCloseKey(hKey);
  return FALSE;
}


//// Open/Save document

BOOL OpenDocument(HWND hWndEdit, char *szFile, int nCodePage, int nBOM)
{
  HANDLE hFile;
  STREAMDATA sd;
  EDITSTREAM es;
  char *pFileName;
  int i;

  //Get full path and check that file exists
  if (!GetFullPathName(szFile, BUFFER_SIZE, buf, &pFileName) || !FileExists(szFile))
  {
    API_LoadString(hLangLib, MSG_FILE_DOES_NOT_EXIST, buf, BUFFER_SIZE);
    wsprintf(buf2, buf, szFile);
    if (MessageBox(hMainWnd, buf2, APP_SHORT_TITLE, MB_OKCANCEL|MB_ICONEXCLAMATION) == IDCANCEL)
    {
      return FALSE;
    }
  }
  lstrcpy(szFile, buf);
  pFileName=szFile + (pFileName - buf);

  //Autodetect code page
  if (nCodePage == -1)
  {
    nCodePage=nDefaultCodePage;
    nBOM=FALSE;

    if ((i=AutodetectCodePage(szFile, DETECTBINARY, ADT_BINARY_ERROR|ADT_REG_CODEPAGE, &nCodePage, &nBOM)) < 0)
    {
      if (i == EDT_BINARY)
      {
        API_LoadString(hLangLib, MSG_ERROR_BINARY, buf, BUFFER_SIZE);
        wsprintf(buf2, buf, szFile);
        if (MessageBox(hMainWnd, buf2, APP_SHORT_TITLE, MB_OKCANCEL|MB_ICONEXCLAMATION|MB_DEFBUTTON2) == IDCANCEL)
          return FALSE;
      }
      else return FALSE;
    }
  }
  else if (nBOM == -1)
    AutodetectCodePage(szFile, DETECTBOM, ADT_DETECT_BOM, 0, &nBOM);


  //Open file
  hFile=API_CreateFile(szFile, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL|FILE_FLAG_SEQUENTIAL_SCAN, NULL);

  if (hFile == INVALID_HANDLE_VALUE)
    return FALSE;

  //Save position of the previous file before load new document
  if (nRecentFiles && *szCurrentFile)
  {
    RecentFilesZero();
    RecentFilesRead();
    RecentFilesUpdate(szCurrentFile, nPosition, MAKELONG(nCurrentCodePage, bCurrentBOM));
    RecentFilesSave();
  }

  if (nBOM)
  {
    if (nCodePage == CP_UNICODE_UCS2_LE)
      SetFilePointer(hFile, 2, NULL, FILE_BEGIN);
    else if (nCodePage == CP_UNICODE_UCS2_BE)
      SetFilePointer(hFile, 2, NULL, FILE_BEGIN);
    else if (nCodePage == CP_UNICODE_UTF8)
      SetFilePointer(hFile, 3, NULL, FILE_BEGIN);
  }

  SetUnixNewLine(FALSE);
  bNewLineDetected=FALSE;
  HideCaret(NULL);

  //Load text
  sd.hFile=hFile;
  sd.nCodePage=nCodePage;
  sd.nBytes=-1;
  sd.nBytesRead=0;
  es.dwCookie=(DWORD)&sd;
  es.pfnCallback=InputStreamCallbackW;
  SendMessage(hWndEdit, EM_STREAMIN, SF_TEXT|SF_UNICODE, (LPARAM)&es);

  ShowCaret(NULL);
  SetModify(FALSE);
  CloseHandle(hFile);

  //Show codepage in statusbar
  DisplayCodePage(nCodePage);

  //Set caption of synchronizing window
  SetWindowText(hSyncWindow, szFile);

  //Set caption of main window
  wsprintf(buf, "%s - %s", pFileName, APP_SHORT_TITLE);
  SetWindowText(hMainWnd, buf);

  //Print if "/p" option used in command line
  if (bGlobalPrint)
  {
    DoFilePrint(hWndEdit);
    DestroyWindow(hMainWnd);
  }

  //Read position of the new document
  if (szCurrentFile != szFile || nCurrentCodePage != nCodePage)
  {
    if (nRecentFiles)
    {
      RecentFilesZero();
      RecentFilesRead();
      RecentFilesUpdate(szFile, -1, MAKELONG(nCodePage, nBOM));
      RecentFilesSave();
    }
    lstrcpy(szCurrentFile, szFile);
    nCurrentCodePage=nCodePage;
    bCurrentBOM=nBOM;
  }
  if (nRecentFiles)
  {
    RecentFilesMenu(hWndEdit);
    SendMessage(hWndEdit, EM_SETSEL, szRecentPositions[0], szRecentPositions[0]);
  }
  return TRUE;
}

DWORD CALLBACK InputStreamCallbackW(DWORD dwCookie, LPBYTE pbBuff, LONG cb, LONG *pcb)
{
  static int nBytesConverted;
  STREAMDATA *lpData=(STREAMDATA *)dwCookie;

  if (nBytesConverted == 0)
  {
    if (lpData->nBytes != -1 && (lpData->nBytesRead+=cb) > lpData->nBytes)
      return 0xFFFFFFFF;

    if (!API_ReadFile(lpData->hFile, pbBuff, (DWORD)cb, (DWORD *)pcb, NULL))
      return 0xFFFFFFFF;

    if (*pcb == 0)
      return 0;
  }

  if (lpData->nCodePage == CP_UNICODE_UCS2_LE)
  {
  }
  else if (lpData->nCodePage == CP_UNICODE_UCS2_BE)
  {
    ChangeByteOrder(pbBuff, *pcb);
  }
  else
  {
    if (nBytesConverted == 0)
    {
      int nBytesRead=*pcb;

      if (lpData->nCodePage == CP_UNICODE_UTF8)
        nBytesConverted=UTF8toUTF16((char *)pbBuff, (unsigned int *)&nBytesRead, (wchar_t *)pcTranslateBuffer, TRANSLATE_BUFFER_SIZE / sizeof(wchar_t)) * sizeof(wchar_t);
      else
        nBytesConverted=MultiByteToWideChar(lpData->nCodePage, 0, (char *)pbBuff, *pcb, (wchar_t *)pcTranslateBuffer, TRANSLATE_BUFFER_SIZE / sizeof(wchar_t)) * sizeof(wchar_t);

      if (lpData->nCodePage == CP_UNICODE_UTF8 && nBytesRead != *pcb)
        SetFilePointer(lpData->hFile, nBytesRead - *pcb, 0, FILE_CURRENT);

      if (nBytesConverted <= cb)
      {
        memcpy(pbBuff, pcTranslateBuffer, nBytesConverted);
        *pcb=nBytesConverted;
        nBytesConverted=0;
      }
      else
      {
        memcpy(pbBuff, pcTranslateBuffer, cb);
        *pcb=cb;
        nBytesConverted-=cb;
      }
    }
    else
    {
      memcpy(pbBuff, pcTranslateBuffer + cb, nBytesConverted);
      *pcb=nBytesConverted;
      nBytesConverted=0;
    }
  }

  if (!bNewLineDetected)
  {
    wchar_t *wpbBuff=(wchar_t *)pbBuff;
    int nBytes=*pcb / sizeof(wchar_t);
    int i;

    for (i=0; i < nBytes; ++i)
    {
      if (wpbBuff[i] == '\n')
      {
        if (i == 0 || wpbBuff[i - 1] != '\r')
          SetUnixNewLine(TRUE);
        bNewLineDetected=TRUE;
        break;
      }
      else if (wpbBuff[i] == '\r')
      {
        bNewLineDetected=TRUE;
      }
    }
  }
  return 0;
}

BOOL SaveDocument(HWND hWndEdit, char *szFile, int nCodePage, BOOL bBOM)
{
  WIN32_FIND_DATA w32fdInfo;
  HANDLE hFile;
  STREAMDATA sd;
  EDITSTREAM es;
  DWORD dwAttr;
  char *pName;
  int nError;
  unsigned int nBytesWritten;

  dwAttr=GetFileAttributes(szFile);
  if (dwAttr != 0xFFFFFFFF)
  {
    if ((dwAttr & FILE_ATTRIBUTE_READONLY) || (dwAttr & FILE_ATTRIBUTE_HIDDEN) || (dwAttr & FILE_ATTRIBUTE_SYSTEM))
      SetFileAttributes(szFile, dwAttr & (!FILE_ATTRIBUTE_READONLY) & (!FILE_ATTRIBUTE_HIDDEN) & (!FILE_ATTRIBUTE_SYSTEM));
    if (bSaveTime)
    {
      if ((hFile=FindFirstFile(szFile, &w32fdInfo)) != INVALID_HANDLE_VALUE)
        FindClose(hFile);
    }
  }

  hFile=API_CreateFile(szFile, GENERIC_WRITE, FILE_SHARE_READ|FILE_SHARE_WRITE, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL|FILE_FLAG_SEQUENTIAL_SCAN, NULL);

  if (hFile == INVALID_HANDLE_VALUE)
  {
    if (dwAttr != 0xFFFFFFFF) SetFileAttributes(szFile, dwAttr);
    return FALSE;
  }

  if (bBOM)
  {
    if (nCodePage == CP_UNICODE_UCS2_LE)
      nError=API_WriteFile(hFile, "\xFF\xFE", 2, (DWORD *)&nBytesWritten, NULL);
    else if (nCodePage == CP_UNICODE_UCS2_BE)
      nError=API_WriteFile(hFile, "\xFE\xFF", 2, (DWORD *)&nBytesWritten, NULL);
    else if (nCodePage == CP_UNICODE_UTF8)
      nError=API_WriteFile(hFile, "\xEF\xBB\xBF", 3, (DWORD *)&nBytesWritten, NULL);

    if (!nError)
    {
      if (dwAttr != 0xFFFFFFFF) SetFileAttributes(szFile, dwAttr);
      return FALSE;
    }
  }

  sd.hFile=hFile;
  sd.nCodePage=nCodePage;
  es.dwCookie=(DWORD)&sd;
  es.pfnCallback=OutputStreamCallbackW;
  SendMessage(hWndEdit, EM_STREAMOUT, SF_TEXT|SF_UNICODE, (LPARAM)&es);

  SetModify(FALSE);
  CloseHandle(hFile);

  //Show codepage in statusbar
  DisplayCodePage(nCodePage);

  //Change back file attributes
  if (dwAttr != 0xFFFFFFFF)
  {
    SetFileAttributes(szFile, dwAttr);
    if (bSaveTime)
    {
      if ((hFile=API_CreateFile(szFile, FILE_WRITE_ATTRIBUTES, 0, NULL, OPEN_EXISTING, FILE_FLAG_BACKUP_SEMANTICS, NULL)) != INVALID_HANDLE_VALUE)
      {
        SetFileTime(hFile, NULL, NULL, &w32fdInfo.ftLastWriteTime);
        CloseHandle(hFile);
      }
    }
  }

  //Set caption of main window
  GetFullPathName(szFile, BUFFER_SIZE, buf, &pName);
  wsprintf(buf2, "%s - %s", pName, APP_SHORT_TITLE);
  SetWindowText(hMainWnd, buf2);

  if (szCurrentFile != szFile || nCurrentCodePage != nCodePage)
  {
    if (nRecentFiles)
    {
      RecentFilesZero();
      RecentFilesRead();
      RecentFilesUpdate(szFile, nPosition, MAKELONG(nCodePage, bBOM));
      RecentFilesSave();
    }
    lstrcpy(szCurrentFile, szFile);
    nCurrentCodePage=nCodePage;
    bCurrentBOM=bBOM;
  }

  return TRUE;
}

DWORD CALLBACK OutputStreamCallbackW(DWORD dwCookie, LPBYTE pbBuff, LONG cb, LONG *pcb)
{
  unsigned int nBytesConverted;
  unsigned int nBytesToWrite;
  unsigned int nBytesWritten;
  unsigned int nBytesRead;
  unsigned char *pDataToWrite=pbBuff;
  STREAMDATA *lpData=(STREAMDATA *)dwCookie;

  if (bUnixNewLine)
  {
    nBytesRead=cb/2;
    nBytesToWrite=TranslateNewLinesToUnixW((wchar_t *)pbBuff, &nBytesRead) * sizeof(wchar_t);
  }
  else nBytesToWrite=cb;

  if (lpData->nCodePage == CP_UNICODE_UCS2_LE)
  {
  }
  else if (lpData->nCodePage == CP_UNICODE_UCS2_BE)
  {
    ChangeByteOrder(pbBuff, nBytesToWrite);
  }
  else
  {
    if (lpData->nCodePage == CP_UNICODE_UTF8)
      nBytesConverted=UTF16toUTF8((wchar_t *)pbBuff, nBytesToWrite/2, (char *)pcTranslateBuffer, TRANSLATE_BUFFER_SIZE);
    else
      nBytesConverted=WideCharToMultiByte(lpData->nCodePage, 0, (wchar_t *)pbBuff, nBytesToWrite/2, (char *)pcTranslateBuffer, TRANSLATE_BUFFER_SIZE, NULL, NULL);

    pDataToWrite=pcTranslateBuffer;
    nBytesToWrite=nBytesConverted;
  }

  if (!API_WriteFile(lpData->hFile, pDataToWrite, nBytesToWrite, (DWORD *)&nBytesWritten, NULL))
    return 0xFFFFFFFF;

  *pcb=cb;

  return 0;
}


//// Code pages

unsigned int CALLBACK CodePageDlgProc(HWND hDlg, UINT uiMsg, WPARAM wParam, LPARAM lParam)
{
  static HWND hWndCP;
  static HWND hWndPreview;
  static HWND hWndAutodetect;
  static RECT rcDlg;
  static RECT rcCP;
  static RECT rcPreview;
  static RECT rcAutodetect;
  static char szFile[MAX_PATH];
  static int nCodePage;
  static BOOL bBOM;
  RECT rcTmp;
  int i;
  wchar_t wc;
  char c='';

  switch(uiMsg)
  {
    case WM_INITDIALOG:
      hWndCP=GetDlgItem(hDlg, IDC_CODEPAGE);
      hWndPreview=GetDlgItem(hDlg, IDC_PREVIEW);
      hWndAutodetect=GetDlgItem(hDlg, IDC_AUTODETECT);

      GetWindowRect(hDlg, &rcDlg);
      GetWindowRect(hWndCP, &rcCP);
      GetWindowRect(hWndPreview, &rcPreview);
      rcDlg.right-=rcDlg.left;
      rcDlg.bottom-=rcDlg.top;
      rcCP.right-=rcCP.left;
      rcCP.bottom-=rcCP.top;
      rcPreview.right-=rcPreview.left;
      rcPreview.bottom-=rcPreview.top;

      nCodePage=nCurrentCodePage;
      FillComboboxCodepage(hWndCP);
      SelectComboboxCodepage(hWndCP, nCodePage);

      if (bSaveDlg)
      {
        SetWindowPos(hDlg, 0, 0, 0, rcDlg.right, rcDlg.bottom - ((rcDlg.bottom + rcDlg.top) - rcPreview.top), SWP_NOMOVE|SWP_NOZORDER);
        SendMessage(hWndAutodetect, WM_SETTEXT, 0, (LPARAM)"&BOM");

        if (nCodePage == CP_UNICODE_UCS2_LE || nCodePage == CP_UNICODE_UCS2_BE || nCodePage == CP_UNICODE_UTF8)
        {
          SendMessage(hWndAutodetect, BM_SETCHECK, (WPARAM)bCurrentBOM, 0);
          EnableWindow(hWndAutodetect, TRUE);
        }
        else
        {
          SendMessage(hWndAutodetect, BM_SETCHECK, (WPARAM)FALSE, 0);
          EnableWindow(hWndAutodetect, FALSE);
        }
      }
      else
      {
        API_LoadString(hLangLib, STR_AUTODETECT, buf, BUFFER_SIZE);
        SendMessage(hWndAutodetect, WM_SETTEXT, 0, (LPARAM)buf);
        SendMessage(hWndAutodetect, BM_SETCHECK, (WPARAM)bAutodetect, 0);
        EnableWindow(hWndCP, !bAutodetect);
      }
      return TRUE;

    case WM_SIZE:
      GetWindowRect(hDlg, &rcTmp);
      GetWindowRect(hWndAutodetect, &rcAutodetect);
      rcAutodetect.left-=rcTmp.left;
      rcAutodetect.top-=rcTmp.top;

      i=LOWORD(lParam) - rcDlg.right;
      rcDlg.right=LOWORD(lParam);
      rcDlg.bottom=HIWORD(lParam);
      rcCP.right+=i;
      rcPreview.right+=i;
      rcAutodetect.left+=i;

      SetWindowPos(hWndCP, 0, 0, 0, rcCP.right, rcCP.bottom, SWP_NOMOVE|SWP_NOZORDER);
      SetWindowPos(hWndPreview, 0, 0, 0, rcPreview.right, rcPreview.bottom, SWP_NOMOVE|SWP_NOZORDER);
      SetWindowPos(hWndAutodetect, 0, rcAutodetect.left, rcAutodetect.top, 0, 0, SWP_NOSIZE|SWP_NOZORDER);
      return TRUE;

    case WM_NOTIFY:
      if (((LPNMHDR)lParam)->code == CDN_FILEOK)
      {
        nCodePage=GetComboboxCodepage(hWndCP);

        if (nCodePage == CP_UNICODE_UCS2_LE || nCodePage == CP_UNICODE_UCS2_BE || nCodePage == CP_UNICODE_UTF8)
        {
          nOfnCodePage=nCodePage;
          if (bSaveDlg)
            bOfnBOM=(BOOL)SendMessage(hWndAutodetect, BM_GETCHECK, 0, 0);
          else
            bOfnBOM=bBOM;
        }
        else if (MultiByteToWideChar(nCodePage, 0, &c, 1, &wc, 1))
        {
          nOfnCodePage=nCodePage;
          bOfnBOM=FALSE;
        }
        else
        {
          API_LoadString(hLangLib, MSG_CP_UNIMPLEMENTED, buf, BUFFER_SIZE);
          MessageBox(hDlg, buf, APP_SHORT_TITLE, MB_OK|MB_ICONERROR);
          SetWindowLong(hDlg, DWL_MSGRESULT, 1);
        }
      }
      else if (((LPNMHDR)lParam)->code == CDN_SELCHANGE)
      {
        if (!bSaveDlg)
        {
          SendMessage(((OFNOTIFY*)lParam)->hdr.hwndFrom, CDM_GETFILEPATH, (LPARAM)MAX_PATH, (WPARAM)szFile);

          if (FilePreview(hWndPreview, szFile, PREVIEW_SIZE, bAutodetect?(ADT_BINARY_ERROR|ADT_REG_CODEPAGE):ADT_DETECT_BOM, &nCodePage, &bBOM) < 0)
          {
            EnableWindow(hWndPreview, FALSE);
            if (bAutodetect) SelectComboboxCodepage(hWndCP, nDefaultCodePage);
            SendMessage(hWndPreview, WM_SETTEXT, 0, (LPARAM)"");
            return TRUE;
          }
          EnableWindow(hWndPreview, TRUE);
          if (bAutodetect) SelectComboboxCodepage(hWndCP, nCodePage);
        }
      }
      return TRUE;

    case WM_COMMAND:
      if (LOWORD(wParam) == IDC_CODEPAGE && HIWORD(wParam) == CBN_SELCHANGE)
      {
        nCodePage=GetComboboxCodepage(hWndCP);

        if (bSaveDlg)
        {
          if (nCodePage == CP_UNICODE_UCS2_LE || nCodePage == CP_UNICODE_UCS2_BE || nCodePage == CP_UNICODE_UTF8)
          {
            EnableWindow(hWndAutodetect, TRUE);
            SendMessage(hWndAutodetect, BM_SETCHECK, (WPARAM)TRUE, 0);
          }
          else
          {
            EnableWindow(hWndAutodetect, FALSE);
            SendMessage(hWndAutodetect, BM_SETCHECK, (WPARAM)FALSE, 0);
          }
        }
        else
        {
          if (FilePreview(hWndPreview, szFile, PREVIEW_SIZE, ADT_DETECT_BOM, &nCodePage, &bBOM) < 0)
            SendMessage(hWndPreview, WM_SETTEXT, 0, (LPARAM)"");
        }
      }
      else if (LOWORD(wParam) == IDC_AUTODETECT)
      {
        if (!bSaveDlg)
        {
          bAutodetect=(BOOL)SendMessage(hWndAutodetect, BM_GETCHECK, 0, 0);
          EnableWindow(hWndCP, !bAutodetect);

          if (FilePreview(hWndPreview, szFile, PREVIEW_SIZE, bAutodetect?(ADT_BINARY_ERROR|ADT_REG_CODEPAGE):ADT_DETECT_BOM, &nCodePage, &bBOM) < 0)
          {
            EnableWindow(hWndPreview, FALSE);
            if (bAutodetect) SelectComboboxCodepage(hWndCP, nDefaultCodePage);
            SendMessage(hWndPreview, WM_SETTEXT, 0, (LPARAM)"");
            return TRUE;
          }
          EnableWindow(hWndPreview, TRUE);
          if (bAutodetect) SelectComboboxCodepage(hWndCP, nCodePage);
        }
      }
      return TRUE;
  }
  return FALSE;
}

void FillComboboxCodepage(HWND hWnd)
{
  int nCount;
  int i;
  CPINFOEX CPInfoEx;

  if (!bEnumCodePages)
  {
    RegEnumCodePages(codepages, sizeof(codepages));
    if (bUnicode) codepages[65000]=TRUE;
    bEnumCodePages=TRUE;
  }

  SendMessage(hWnd, CB_ADDSTRING, 0, (LPARAM)STR_SYSTEM_ANSI);
  SendMessage(hWnd, CB_ADDSTRING, 0, (LPARAM)STR_SYSTEM_OEM);
  SendMessage(hWnd, CB_ADDSTRING, 0, (LPARAM)STR_UNICODE_UCS2_LE);
  SendMessage(hWnd, CB_ADDSTRING, 0, (LPARAM)STR_UNICODE_UCS2_BE);
  SendMessage(hWnd, CB_ADDSTRING, 0, (LPARAM)STR_UNICODE_UTF8);
  nCount=SendMessage(hWnd, CB_GETCOUNT, 0, 0);

  for (i=0; i <= 65535; ++i)
  {
    if (codepages[i])
    {
      if (GetCPInfoExPtr && (*GetCPInfoExPtr)(i, 0, &CPInfoEx) && i == xatoi(CPInfoEx.CodePageName))
      {
        SendMessage(hWnd, CB_ADDSTRING, 0, (LPARAM)CPInfoEx.CodePageName);
      }
      else
      {
        wsprintf(buf, "%d", i);
        SendMessage(hWnd, CB_ADDSTRING, 0, (LPARAM)buf);
      }
      codepages[i]=nCount++;
    }
  }
}

BOOL RegEnumCodePages(int *codepages, int size)
{
  HKEY hKey;
  DWORD dwSizeValue;
  DWORD dwSizeString;
  DWORD dwType;
  DWORD dwIndex=0;
  int i;

  memset(codepages, 0, size);

  if (RegOpenKeyEx(HKEY_LOCAL_MACHINE, "SYSTEM\\CurrentControlSet\\Control\\Nls\\CodePage", 0, KEY_READ, &hKey) != ERROR_SUCCESS)
    return FALSE;

  while(1)
  {
    dwSizeValue=BUFFER_SIZE;
    dwSizeString=BUFFER_SIZE;
    buf2[0]='\0';

    if (RegEnumValue(hKey, dwIndex++, buf, &dwSizeValue, NULL, &dwType, (LPBYTE)&buf2, &dwSizeString) != ERROR_SUCCESS)
      break;

    if (*buf2 != '\0' && (i=xatoi(buf)) != 0 && i < size)
      codepages[i]=TRUE;
  }
  RegCloseKey(hKey);

  return TRUE;
}

int GetComboboxCodepage(HWND hWnd)
{
  int nCodePage;

  SendMessage(hWnd, CB_GETLBTEXT, (WPARAM)SendMessage(hWnd, CB_GETCURSEL, 0, 0), (LPARAM)buf);

  if (!lstrcmp(buf, STR_SYSTEM_ANSI))
    nCodePage=nAnsiCodePage;
  else if (!lstrcmp(buf, STR_SYSTEM_OEM))
    nCodePage=nOemCodePage;
  else
    nCodePage=xatoi(buf);

  return nCodePage;
}

int SelectComboboxCodepage(HWND hWnd, int nCodepage)
{
  int nSelectIndex;

  if (nCodepage == nAnsiCodePage)
    nSelectIndex=0;
  else if (nCodepage == nOemCodePage)
    nSelectIndex=1;
  else if (nCodepage == CP_UNICODE_UCS2_LE)
    nSelectIndex=2;
  else if (nCodepage == CP_UNICODE_UCS2_BE)
    nSelectIndex=3;
  else if (nCodepage == CP_UNICODE_UTF8)
    nSelectIndex=4;
  else
    nSelectIndex=codepages[nCodepage];

  SendMessage(hWnd, CB_SETCURSEL, (WPARAM)nSelectIndex, 0);

  return nSelectIndex;
}

int FilePreview(HWND hWnd, char *pFile, int nPreviewBytes, DWORD Flags, int *nCodePage, BOOL *bBOM)
{
  HANDLE hFile;
  STREAMDATA sd;
  EDITSTREAM es;
  int i;

  if (IsFile(pFile) != ERROR_SUCCESS)
    return EDT_OPEN;

  if ((i=AutodetectCodePage(pFile, DETECTBINARY, Flags, nCodePage, bBOM)) < 0)
    return i;

  if ((hFile=API_CreateFile(pFile, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL|FILE_FLAG_SEQUENTIAL_SCAN, NULL)) == INVALID_HANDLE_VALUE)
    return EDT_OPEN;

  if (*bBOM)
  {
    if (*nCodePage == CP_UNICODE_UCS2_LE)
      SetFilePointer(hFile, 2, NULL, FILE_BEGIN);
    else if (*nCodePage == CP_UNICODE_UCS2_BE)
      SetFilePointer(hFile, 2, NULL, FILE_BEGIN);
    else if (*nCodePage == CP_UNICODE_UTF8)
      SetFilePointer(hFile, 3, NULL, FILE_BEGIN);
  }

  sd.hFile=hFile;
  sd.nCodePage=*nCodePage;
  sd.nBytes=nPreviewBytes;
  sd.nBytesRead=0;
  es.dwCookie=(DWORD)&sd;
  es.pfnCallback=InputStreamCallbackW;
  SendMessage(hWnd, EM_STREAMIN, SF_TEXT|SF_UNICODE, (LPARAM)&es);

  CloseHandle(hFile);
  return 0;
}

int AutodetectCodePage(char *pFile, DWORD dwBytesToCheck, DWORD Flags, int *nCodePage, BOOL *bBOM)
{
  HANDLE hFile;
  DWORD dwBytesRead;
  DWORD dwCount;
  unsigned char *pBuffer;
  int nUTF=0;
  int i;

  if (!dwBytesToCheck)
    return EDT_BYTESTOCHECK;
  if (!Flags)
    return EDT_FLAGS;

  if (Flags & ADT_REG_CODEPAGE)
  {
    if (nRecentFiles)
    {
      RecentFilesZero();
      RecentFilesRead();
    }
    if (nRecentFiles && RecentFilesGet(pFile, 0, &i) && i)
    {
      if (nCodePage) *nCodePage=LOWORD(i);
      if (bBOM) *bBOM=HIWORD(i);
      Flags&=~ADT_DETECT_CODEPAGE;
      Flags&=~ADT_DETECT_BOM;
    }
    else
    {
      Flags&=~ADT_REG_CODEPAGE;
      Flags|=ADT_DETECT_CODEPAGE;
      Flags|=ADT_DETECT_BOM;
    }
  }

  if (Flags & ADT_BINARY_ERROR || Flags & ADT_DETECT_CODEPAGE || Flags & ADT_DETECT_BOM)
  {
    if ((hFile=API_CreateFile(pFile, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL|FILE_FLAG_SEQUENTIAL_SCAN, NULL)) == INVALID_HANDLE_VALUE)
      return EDT_OPEN;

    if (!(pBuffer=(unsigned char *)API_HeapAlloc(GetProcessHeap(), 0, dwBytesToCheck + 1)))
    {
      CloseHandle(hFile);
      return EDT_ALLOC;
    }

    if (!API_ReadFile(hFile, pBuffer, dwBytesToCheck, &dwBytesRead, NULL))
    {
      HeapFree(GetProcessHeap(), 0, (LPVOID)pBuffer);
      CloseHandle(hFile);
      return EDT_READ;
    }
    CloseHandle(hFile);
  }

  if (Flags & ADT_BINARY_ERROR || Flags & ADT_DETECT_CODEPAGE)
  {
    if (dwBytesRead)
    {
      for (dwCount=0, --dwBytesRead; dwCount < dwBytesRead; ++dwCount)
      {
        if (Flags & ADT_BINARY_ERROR)
        {
          if (pBuffer[dwCount] == 0x00 && pBuffer[dwCount + 1] == 0x00)
          {
            HeapFree(GetProcessHeap(), 0, (LPVOID)pBuffer);
            return EDT_BINARY;
          }
        }
        if (Flags & ADT_DETECT_CODEPAGE)
        {
          if (nUTF == 0 && dwCount % 2 == 0)
          {
            if (pBuffer[dwCount] != 0x00 && pBuffer[dwCount + 1] == 0x00)
              nUTF=CP_UNICODE_UCS2_LE;
            else if (pBuffer[dwCount] == 0x00 && pBuffer[dwCount + 1] != 0x00)
              nUTF=CP_UNICODE_UCS2_BE;
          }
        }
      }
    }
  }

  if (Flags & ADT_DETECT_CODEPAGE || Flags & ADT_DETECT_BOM)
  {
    if (pBuffer[0] == 0xFF && pBuffer[1] == 0xFE)
    {
      if (Flags & ADT_DETECT_CODEPAGE) *nCodePage=CP_UNICODE_UCS2_LE;
      if (Flags & ADT_DETECT_BOM) *bBOM=TRUE;
    }
    else if (pBuffer[0] == 0xFE && pBuffer[1] == 0xFF)
    {
      if (Flags & ADT_DETECT_CODEPAGE) *nCodePage=CP_UNICODE_UCS2_BE;
      if (Flags & ADT_DETECT_BOM) *bBOM=TRUE;
    }
    else if (pBuffer[0] == 0xEF && pBuffer[1] == 0xBB && pBuffer[2] == 0xBF)
    {
      if (Flags & ADT_DETECT_CODEPAGE) *nCodePage=CP_UNICODE_UTF8;
      if (Flags & ADT_DETECT_BOM) *bBOM=TRUE;
    }
    else if (nUTF)
    {
      *nCodePage=nUTF;
      if (Flags & ADT_DETECT_BOM) *bBOM=FALSE;
    }
    else
    {
      if (Flags & ADT_DETECT_CODEPAGE) *nCodePage=nDefaultCodePage;
      if (Flags & ADT_DETECT_BOM) *bBOM=FALSE;
    }
  }

  if (Flags & ADT_BINARY_ERROR || Flags & ADT_DETECT_CODEPAGE || Flags & ADT_DETECT_BOM)
  {
    HeapFree(GetProcessHeap(), 0, (LPVOID)pBuffer);
  }
  return 0;

/*
  int counter[128];
  int i, exchars=0;
  unsigned char ch;
  char szOEMwatermark[]="\xAE\xA5\xA0\xA8\xBA\xCD\xB3\xC4\xB0\xB1\xB2\xDB";
  char szANSIwatermark[]="\xEE\xE5\xE0\xE8\xED\xF2\xCE\xC5\xC0\xC8\xD2\x97";
  char szKOIwatermark[]="\xCF\xC5\xC1\xC9\xCE\xD4\xEF\xE5\x80";
  char szUTF8watermark[]="\xD0\xD1";
  int iOEMrate=0, iANSIrate=0, iKOIrate=0, iUTF8rate=0;

  //Count number of each character in input buffer
  ZeroMemory(counter, 128*sizeof(int));
  for (i=0;i <= len-1;i++)
  {
    if (pcBuffer[i] >= 0x80)
    {
      exchars++;
      counter[pcBuffer[i]-0x80]++;
    }
  }

  //Give it up if there's no representative selection
  if (exchars<15)
  {
    DisplayCodePage(CP_ACP);
    return TRUE;
  }

  for (i=0;i <= 9;i++)
  {
    ch=getmaxelement(counter, 128);
    if (!counter[ch]) break;

    if (strchr(szOEMwatermark, ch+0x80)) iOEMrate+=counter[ch];
    if (strchr(szANSIwatermark, ch+0x80)) iANSIrate+=counter[ch];
    if (strchr(szKOIwatermark, ch+0x80)) iKOIrate+=counter[ch];
    if (strchr(szUTF8watermark, ch+0x80)) iUTF8rate+=counter[ch];
    counter[ch]=0;
  }

  iANSIrate*=12; //because ANSI is the most popular in Win32

  if (iANSIrate >= iOEMrate && iANSIrate >= iKOIrate && iANSIrate >= iUTF8rate)
    DisplayCodePage(CP_ACP);
  else if (iOEMrate >= iKOIrate && iOEMrate >= iUTF8rate)
    DisplayCodePage(nOemCodePage);
  if (iKOIrate >= iUTF8rate)
    DisplayCodePage(KOI8_R);
  return TRUE;
*/
}

BOOL DisplayCodePage(int cp)
{
  CPINFOEX CPInfoEx;

  if (cp == CP_UNICODE_UCS2_LE)
  {
    lstrcpy(buf, STR_UNICODE_UCS2_LE);
  }
  else if (cp == CP_UNICODE_UCS2_BE)
  {
    lstrcpy(buf, STR_UNICODE_UCS2_BE);
  }
  else if (cp == CP_UNICODE_UTF8)
  {
    lstrcpy(buf, STR_UNICODE_UTF8);
  }
  else
  {
    if (GetCPInfoExPtr && (*GetCPInfoExPtr)(cp, 0, &CPInfoEx) && cp == xatoi(CPInfoEx.CodePageName))
      lstrcpy(buf, CPInfoEx.CodePageName);
    else
      wsprintf(buf, "CP-%u", cp);
  }

  SendMessage(hStatus, SB_SETTEXT, 4, (LPARAM)buf);
  return TRUE;
}

unsigned int UTF8toUTF16(const char *buf, unsigned int *len, wchar_t *tbuf, unsigned int tlen)
{
  const unsigned char *ubuf=(const unsigned char *)buf;
  unsigned int i;
  unsigned int ti;

  for (i=0, ti=0; i < *len && ti < tlen && ubuf[i]; ++ti)
  {
    if (ubuf[i] < 0x80)
    {
      tbuf[ti]=ubuf[i++];
    }
    else if (ubuf[i] < 0x80 + 0x40 + 0x20)
    {
      tbuf[ti]=(ubuf[i++] & 0x1F) << 6;
      if (i >= *len || !ubuf[i]) {*len=i - 1; return ti;}
      tbuf[ti]=tbuf[ti] + (ubuf[i++] & 0x7F);
    }
    else
    {
      tbuf[ti]=(ubuf[i++] & 0xF) << 12;
      if (i >= *len || !ubuf[i]) {*len=i - 1; return ti;}
      tbuf[ti]=tbuf[ti] + ((ubuf[i++] & 0x7F) << 6);
      if (i >= *len || !ubuf[i]) {*len=i - 2; return ti;}
      tbuf[ti]=tbuf[ti] + (ubuf[i++] & 0x7F);
    }
  }
  if (i < *len && ti < tlen)
    tbuf[ti++]='\0';
  *len=i;
  return ti;
}

unsigned int UTF16toUTF8(const wchar_t *tbuf, unsigned int tlen, char *buf, unsigned int len)
{
  unsigned char *ubuf=(unsigned char *)buf;
  unsigned int i;
  unsigned int ti;

  for (i=0, ti=0; ti < tlen && tbuf[ti]; ++ti)
  {
    if (tbuf[ti] < 0x80)
    {
      if (i + 1 > len) return i;
      ubuf[i++]=(unsigned char)tbuf[ti];
    }
    else if (tbuf[ti] < 0x800)
    {
      if (i + 2 > len) return i;
      ubuf[i++]=0xC0|((tbuf[ti] >> 6) & 0x1F);
      ubuf[i++]=0x80|(tbuf[ti] & 0x3F);
    }
    else
    {
      if (i + 3 > len) return i;
      ubuf[i++]=0xE0|((tbuf[ti] >> 12) & 0xF);
      ubuf[i++]=0x80|((tbuf[ti] >> 6) & 0x3F);
      ubuf[i++]=0x80|(tbuf[ti] & 0x3F);
    }
  }
  if (ti < tlen)
    ubuf[i++]='\0';
  return i;
}

void ChangeByteOrder(unsigned char *buf, unsigned int len)
{
  unsigned char ch;
  unsigned int a;
  unsigned int b;

  for (a=0, b=1; a < len; a+=2, b+=2)
  {
    ch=buf[a];
    buf[a]=buf[b];
    buf[b]=ch;
  }
}

int getmaxelement(int *base, int iCount)
{
  int maxvalue, number, i;

  if (iCount == 0) return 0;
  maxvalue=base[0];
  number=0;
  for (i=1;i <= iCount-1;i++)
  {
    if (base[i]>maxvalue)
    {
      maxvalue=base[i];
      number=i;
    }
  }
  return number;
}

unsigned int TranslateNewLinesToUnixW(wchar_t *tbuf, unsigned int *tlen)
{
  unsigned int a;
  unsigned int b;

  for (a=0, b=0; a < *tlen && tbuf[a]; ++a, ++b)
  {
    if (tbuf[a] == '\r' && tbuf[a + 1] == '\n') ++a;

    tbuf[b]=tbuf[a];
  }
  *tlen=a;
  return b;
}


//// Find/Replace

BOOL CALLBACK FindAndReplaceDlgProcW(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
  static HWND hWndText;
  static HWND hWndEdit;
  static HWND hWndFindNext;
  static HWND hWndMatchCase;
  static HWND hWndWholeWord;
  static HWND hWndEscapeSeq;
  static HWND hWndForward;
  static HWND hWndBackward;
  static HWND hWndBeginning;
  static HWND hWndNewText;
  static HWND hWndReplace;
  static HWND hWndReplaceAll;
  static HWND hWndInSelection;
  static HWND hFocus;
  wchar_t *cb;
  int nQueryLen;
  int nReplaceLen;
  int result;
  BOOL enable=TRUE;
  BOOL replace=FALSE;
  BOOL replace_all=FALSE;

  switch(msg)
  {
    case WM_INITDIALOG:
      SendMessage(hDlg, WM_SETICON, (WPARAM)ICON_BIG, (LPARAM)API_LoadIcon(hLangLib, MAKEINTRESOURCE(IDI_ICON)));
      hWndEdit=(HWND)lParam;
      hWndFindNext=GetDlgItem(hDlg, IDC_FINDNEXT);
      hWndText=GetDlgItem(hDlg, IDC_TEXT);
      hWndMatchCase=GetDlgItem(hDlg, IDC_MATCHCASE);
      hWndWholeWord=GetDlgItem(hDlg, IDC_WHOLEWORD);
      hWndEscapeSeq=GetDlgItem(hDlg, IDC_ESCAPESEQ);
      hWndForward=GetDlgItem(hDlg, IDC_FORWARD);
      hWndBackward=GetDlgItem(hDlg, IDC_BACKWARD);
      hWndBeginning=GetDlgItem(hDlg, IDC_BEGINNING);
      if (bReplaceDlg == TRUE)
      {
        hWndNewText=GetDlgItem(hDlg, IDC_NEWTEXT);
        hWndReplace=GetDlgItem(hDlg, IDC_REPLACE);
        hWndReplaceAll=GetDlgItem(hDlg, IDC_ALL);
        hWndInSelection=GetDlgItem(hDlg, IDC_INSEL);
      }

      if (chrg.cpMin == chrg.cpMax || ftflags & FR_SELECTION)
      {
        if (wszSearch_orig) API_SetWindowTextW(hWndText, wszSearch_orig);
      }
      else
      {
        if (cb=GetSelTextW(hWndEdit, chrg))
        {
          API_SetWindowTextW(hWndText, cb);
          FreeSelTextW(cb);
        }
      }

      if (bReplaceDlg == TRUE && wszReplace_orig) API_SetWindowTextW(hWndNewText, wszReplace_orig);

      SendMessage(hWndForward, BM_SETCHECK, BST_UNCHECKED, 0);
      SendMessage(hWndBackward, BM_SETCHECK, BST_UNCHECKED, 0);
      SendMessage(hWndBeginning, BM_SETCHECK, BST_UNCHECKED, 0);
      if (bReplaceDlg == TRUE)
      {
        SendMessage(hWndInSelection, BM_SETCHECK, BST_UNCHECKED, 0);
        EnableWindow(hWndFindNext, TRUE);
        EnableWindow(hWndReplace, TRUE);
      }
      if ((ftflags & FR_DOWN) && !(ftflags & FR_BEGINNING) && !(ftflags & FR_SELECTION))
        SendMessage(hWndForward, BM_SETCHECK, BST_CHECKED, 0);
      else if (ftflags & FR_UP)
        SendMessage(hWndBackward, BM_SETCHECK, BST_CHECKED, 0);
      else if (ftflags & FR_BEGINNING)
        SendMessage(hWndBeginning, BM_SETCHECK, BST_CHECKED, 0);
      else if (bReplaceDlg == TRUE && (ftflags & FR_SELECTION))
      {
        SendMessage(hWndInSelection, BM_SETCHECK, BST_CHECKED, 0);
        EnableWindow(hWndFindNext, FALSE);
        EnableWindow(hWndReplace, FALSE);
      }
      SendMessage(hWndMatchCase, BM_SETCHECK, (BOOL)(ftflags & FR_MATCHCASE), 0);
      SendMessage(hWndWholeWord, BM_SETCHECK, (BOOL)(ftflags & FR_WHOLEWORD), 0);
      SendMessage(hWndEscapeSeq, BM_SETCHECK, (BOOL)(ftflags & FR_ESCAPESEQ), 0);
      break;

    case WM_COMMAND:
      if (LOWORD(wParam) == IDC_NEWTEXT)
        return TRUE;
      else if (LOWORD(wParam) == IDC_MATCHCASE)
      {
        if (SendMessage(hWndMatchCase, BM_GETCHECK, 0, 0)) ftflags|=FR_MATCHCASE;
        else ftflags&=~FR_MATCHCASE;
        return TRUE;
      }
      else if (LOWORD(wParam) == IDC_WHOLEWORD)
      {
        if (SendMessage(hWndWholeWord, BM_GETCHECK, 0, 0)) ftflags|=FR_WHOLEWORD;
        else ftflags&=~FR_WHOLEWORD;
        return TRUE;
      }
      else if (LOWORD(wParam) == IDC_ESCAPESEQ)
      {
        if (SendMessage(hWndEscapeSeq, BM_GETCHECK, 0, 0)) ftflags|=FR_ESCAPESEQ;
        else ftflags&=~FR_ESCAPESEQ;
        return TRUE;
      }
      else if (LOWORD(wParam) == IDC_FORWARD)
      {
        ftflags&=~FR_UP&~FR_BEGINNING&~FR_SELECTION;
        ftflags|=FR_DOWN;
      }
      else if (LOWORD(wParam) == IDC_BACKWARD)
      {
        ftflags&=~FR_DOWN&~FR_BEGINNING&~FR_SELECTION;
        ftflags|=FR_UP;
      }
      else if (LOWORD(wParam) == IDC_BEGINNING)
      {
        ftflags&=~FR_UP&~FR_SELECTION;
        ftflags|=FR_DOWN|FR_BEGINNING;
      }
      else if (LOWORD(wParam) == IDC_INSEL)
      {
        ftflags&=~FR_UP&~FR_BEGINNING;
        ftflags|=FR_DOWN|FR_SELECTION;
      }
      if (LOWORD(wParam) == IDC_TEXT ||
          LOWORD(wParam) == IDC_FORWARD ||
          LOWORD(wParam) == IDC_BACKWARD ||
          LOWORD(wParam) == IDC_BEGINNING ||
          LOWORD(wParam) == IDC_INSEL)
      {
        EnableWindow(hWndFindNext, TRUE);
        if (bReplaceDlg == TRUE)
        {
          EnableWindow(hWndReplace, TRUE);
          EnableWindow(hWndReplaceAll, TRUE);
        }

        if (API_GetWindowTextLengthW(hWndText) == 0)
        {
          EnableWindow(hWndFindNext, FALSE);
          if (bReplaceDlg == TRUE)
          {
            EnableWindow(hWndReplace, FALSE);
            EnableWindow(hWndReplaceAll, FALSE);
          }
        }
        else if (bReplaceDlg == TRUE && SendMessage(hWndInSelection, BM_GETCHECK, 0, 0))
        {
          EnableWindow(hWndFindNext, FALSE);
          EnableWindow(hWndReplace, FALSE);
        }
        return TRUE;
      }
      else if (LOWORD(wParam) == IDCANCEL)
      {
        DestroyWindow(hDlg);
        hDlgModeless=NULL;
        return TRUE;
      }
      else if (LOWORD(wParam) == IDC_REPLACE)
      {
        replace=TRUE;
      }
      else if (LOWORD(wParam) == IDC_ALL)
      {
        replace_all=TRUE;
      }
      if (LOWORD(wParam) == IDC_FINDNEXT ||
          LOWORD(wParam) == IDC_REPLACE ||
          LOWORD(wParam) == IDC_ALL)
      {
        FreeMemorySearch();

        nQueryLen=API_GetWindowTextLengthW(hWndText);
        if (bReplaceDlg == TRUE) nReplaceLen=API_GetWindowTextLengthW(hWndNewText);

        if (wszSearch_orig=wszSearch=(wchar_t *)API_HeapAlloc(GetProcessHeap(), 0, nQueryLen*sizeof(wchar_t) + 2))
        {
          API_GetWindowTextW(hWndText, wszSearch_orig, nQueryLen + 1);
        }
        else goto Error;

        if (bReplaceDlg == TRUE)
        {
          if (wszReplace_orig=wszReplace=(wchar_t *)API_HeapAlloc(GetProcessHeap(), 0, nReplaceLen*sizeof(wchar_t) + 2))
          {
            API_GetWindowTextW(hWndNewText, wszReplace_orig, nReplaceLen + 1);
          }
          else goto Error;
        }

        if (ftflags & FR_ESCAPESEQ)
        {
          if (wszSearch=(wchar_t *)API_HeapAlloc(GetProcessHeap(), 0, nQueryLen*sizeof(wchar_t) + 2))
          {
            if (!EscapeStringToEscapeDataW(wszSearch_orig, wszSearch))
            {
              API_LoadString(hLangLib, MSG_ERROR_SYNTAX, buf, BUFFER_SIZE);
              MessageBox(hDlg, buf, APP_SHORT_TITLE, MB_OK|MB_ICONERROR);
              goto Error;
            }
          }
          else goto Error;

          if (bReplaceDlg == TRUE)
          {
            if (wszReplace=(wchar_t *)API_HeapAlloc(GetProcessHeap(), 0, nReplaceLen*sizeof(wchar_t) + 2))
            {
              if (!EscapeStringToEscapeDataW(wszReplace_orig, wszReplace))
              {
                API_LoadString(hLangLib, MSG_ERROR_SYNTAX, buf, BUFFER_SIZE);
                MessageBox(hDlg, buf, APP_SHORT_TITLE, MB_OK|MB_ICONERROR);
                goto Error;
              }
            }
            else goto Error;
          }
        }

        hFocus=GetFocus();
        SetFocus(hWndEdit);

        if (bReplaceDlg == TRUE && (replace == TRUE || replace_all == TRUE))
          result=ReplaceTextW(hWndEdit, replace_all);
        else
          result=FindTextW(hWndEdit);

        if (result == -1)
        {
          if (replace_all == TRUE)
          {
            API_LoadString(hLangLib, MSG_REPLACE_COUNT, buf, BUFFER_SIZE);
            wsprintf(buf2, buf, nReplaceCount);
            MessageBox(hDlg, buf2, APP_SHORT_TITLE, MB_OK|MB_ICONINFORMATION);
          }
          else
          {
            API_LoadString(hLangLib, MSG_SEARCH_ENDED, buf, BUFFER_SIZE);
            MessageBox(hDlg, buf, APP_SHORT_TITLE, MB_OK|MB_ICONINFORMATION);
          }
        }
        else
        {
          if (replace_all == FALSE && (ftflags & FR_BEGINNING))
          {
            ftflags&=~FR_BEGINNING;
            SendMessage(hWndBeginning, BM_SETCHECK, BST_UNCHECKED, 0);
            SendMessage(hWndForward, BM_SETCHECK, BST_CHECKED, 0);
          }
        }
        SetFocus(hFocus);
        return TRUE;

        Error:
        FreeMemorySearch();
        return TRUE;
      }
  }
  return FALSE;
}

int FindTextW(HWND hWndEdit)
{
  FINDTEXTEXW ftW;
  int nResult;
  wchar_t *cb;

  if ((ftflags & FR_DOWN) && !(ftflags&FR_BEGINNING) && !(ftflags&FR_SELECTION))
  {
    ftW.chrg.cpMin=chrg.cpMax;
    ftW.chrg.cpMax=-1;
  }
  else if (ftflags & FR_UP)
  {
    ftW.chrg.cpMin=chrg.cpMin;
    ftW.chrg.cpMax=0;
  }
  else if (ftflags & FR_BEGINNING)
  {
    ftW.chrg.cpMin=0;
    ftW.chrg.cpMax=-1;
  }
  ftW.lpstrText=wszSearch;

  if ((nResult=SendMessage(hWndEdit, EM_FINDTEXTEXW, ftflags, (LPARAM)&ftW)) != -1)
  {
    ftW.chrg.cpMin=chrg.cpMin;
    ftW.chrg.cpMax=chrg.cpMax;
    SendMessage(hWndEdit, EM_EXSETSEL, 0, (LPARAM)&ftW.chrgText);

    //EM_FINDTEXTEX bug workarround
    if (ftW.chrgText.cpMax - ftW.chrgText.cpMin == 1)
    {
      if (cb=GetSelTextW(hWndEdit, ftW.chrgText))
      {
        if (*cb == 0x00) nResult=-1;
        FreeSelTextW(cb);
      }
      else nResult=-1;

      if (nResult == -1) SendMessage(hWndEdit, EM_EXSETSEL, 0, (LPARAM)&ftW.chrg);
    }
  }
  return nResult;
}

int ReplaceTextW(HWND hWndEdit, BOOL all)
{
  FINDTEXTEXW ftW;
  CHARRANGE crInitial;
  CHARRANGE crSelection;
  CHARRANGE crPrevious;
  wchar_t *cb;
  BOOL bFirstCall=TRUE;
  int nFirstLine;
  int nCurrentLine;
  int nResult;
  int i;

  nReplaceCount=0;

  if (all)
  {
    crInitial.cpMin=chrg.cpMin;
    crInitial.cpMax=chrg.cpMax;
    nFirstLine=SendMessage(hWndEdit, EM_GETFIRSTVISIBLELINE, 0, 0);
  }
  if (ftflags & FR_SELECTION)
  {
    crSelection.cpMin=chrg.cpMin;
    crSelection.cpMax=chrg.cpMax;
  }
  else if (!(all && (ftflags & FR_BEGINNING)))
  {
    if (cb=GetSelTextW(hWndEdit, chrg))
    {
      if (((ftflags & FR_MATCHCASE) && !API_lstrcmpW(wszSearch, cb)) ||
          (!(ftflags & FR_MATCHCASE) && !API_lstrcmpiW(wszSearch, cb)))
      {
        FreeSelTextW(cb);
        goto Replace;
      }
      FreeSelTextW(cb);
    }
    else return -1;
  }
  goto Find;

  do
  {
    Replace:
    crPrevious.cpMin=chrg.cpMin;
    crPrevious.cpMax=chrg.cpMax;

    ++nReplaceCount;
    ReplaceSelW(hWndEdit, wszReplace);
    i=API_lstrlenW(wszSearch) - API_lstrlenW(wszReplace);

    if (all)
    {
      if (crInitial.cpMin >= crPrevious.cpMax) crInitial.cpMin-=i;
      else if (crInitial.cpMin < crPrevious.cpMax && crInitial.cpMin > crPrevious.cpMin) crInitial.cpMin=crPrevious.cpMin;

      if (crInitial.cpMax >= crPrevious.cpMax) crInitial.cpMax-=i;
      else if (crInitial.cpMax < crPrevious.cpMax && crInitial.cpMax > crPrevious.cpMin) crInitial.cpMax=nPosition;
    }
    if (ftflags & FR_SELECTION) crSelection.cpMax-=i;
    else if (ftflags & FR_UP) SendMessage(hWndEdit, EM_SETSEL, crPrevious.cpMin, crPrevious.cpMin);

    Find:
    if (ftflags & FR_SELECTION)
    {
      ftW.chrg.cpMin=(bFirstCall)?crSelection.cpMin:chrg.cpMax;
      ftW.chrg.cpMax=crSelection.cpMax;
    }
    else if (ftflags & FR_BEGINNING)
    {
      ftW.chrg.cpMin=(bFirstCall)?0:chrg.cpMax;
      ftW.chrg.cpMax=-1;
    }
    else if (ftflags & FR_DOWN)
    {
      ftW.chrg.cpMin=chrg.cpMax;
      ftW.chrg.cpMax=-1;
    }
    else if (ftflags & FR_UP)
    {
      ftW.chrg.cpMin=chrg.cpMin;
      ftW.chrg.cpMax=0;
    }
    bFirstCall=FALSE;
    ftW.lpstrText=wszSearch;

    if ((nResult=SendMessage(hWndEdit, EM_FINDTEXTEXW, ftflags, (LPARAM)&ftW)) != -1)
    {
      ftW.chrg.cpMin=chrg.cpMin;
      ftW.chrg.cpMax=chrg.cpMax;
      SendMessage(hWndEdit, EM_EXSETSEL, 0, (LPARAM)&ftW.chrgText);

      //EM_FINDTEXTEX bug workarround
      if (ftW.chrgText.cpMax - ftW.chrgText.cpMin == 1)
      {
        if (cb=GetSelTextW(hWndEdit, ftW.chrgText))
        {
          if (*cb == 0x00) nResult=-1;
          FreeSelTextW(cb);
        }
        else nResult=-1;

        if (nResult == -1) SendMessage(hWndEdit, EM_EXSETSEL, 0, (LPARAM)&ftW.chrg);
      }
    }
  }
  while (all && nResult != -1);

  if (all)
  {
    SendMessage(hWndEdit, EM_EXSETSEL, 0, (LPARAM)&crInitial);
    nCurrentLine=SendMessage(hWndEdit, EM_GETFIRSTVISIBLELINE, 0, 0);
    SendMessage(hWndEdit, EM_LINESCROLL, 0, nFirstLine - nCurrentLine);
  }
  return nResult;
}

BOOL EscapeStringToEscapeDataW(wchar_t *input, wchar_t *output)
{
  wchar_t *a=input;
  wchar_t *b=output;
  unsigned char *c;
  char hex[2];

  for (hex[2]='\0'; *a; ++b, ++a)
  {
    if (*a == '\\')
    {
      if (*++a == '\\') *b='\\';
      else if (*a == 'n') *b='\r';
      else if (*a == 't') *b='\t';
      else if (*a == '[')
      {
        --b, ++a;

        do
        {
          c=(unsigned char *)++b;
          hex[0]=(char)*a;
          if (*a == 0) goto Error;
          hex[1]=(char)*++a;
          if (*a == 0) goto Error;
          *c=hex2dec(hex);
          if (*c == -1) goto Error;
          while (*++a == ' ');

          ++c;
          hex[0]=(char)*a;
          if (*a == 0) goto Error;
          hex[1]=(char)*++a;
          if (*a == 0) goto Error;
          *c=hex2dec(hex);
          if (*c == -1) goto Error;
          while (*++a == ' ');
        }
        while (*a && *a != ']');
      }
      else goto Error;
    }
    else *b=*a;
  }
  *b='\0';
  return TRUE;

  Error:
  *output='\0';
  return FALSE;
}

void EscapeDataToEscapeStringW(wchar_t *input, wchar_t *output)
{
  wchar_t *a;
  wchar_t *b;

  for (a=input, b=output; *a; ++b, ++a)
  {
    if (*a == '\t') *b='\\', *++b='t';
    else if (*a == '\r') *b='\\', *++b='n';
    else if (*a == '\\') *b='\\', *++b='\\';
    else *b=*a;
  }
  *b='\0';
}


//// Paste operation

void ReplaceSelA(HWND hWndEdit, char *pData)
{
  wchar_t *pDataW;
  int nLen;
  int nLenW;

  nLen=lstrlen(pData) + 1;
  nLenW=nLen * sizeof(wchar_t);

  if (pDataW=(wchar_t *)API_HeapAlloc(GetProcessHeap(), 0, nLenW + 2))
  {
    MultiByteToWideChar(CP_ACP, 0, pData, nLen, pDataW, nLenW);
    ReplaceSelW(hWndEdit, pDataW);
    HeapFree(GetProcessHeap(), 0, (LPVOID)pDataW);
  }
}

void ReplaceSelW(HWND hWndEdit, wchar_t *pData)
{
  EDITSTREAM es;
  PASTEDATA pd;

  pd.pData=(unsigned char *)pData;
  pd.nLength=0;
  es.dwCookie=(DWORD)&pd;
  es.pfnCallback=ReplaceSelCallbackW;
  SendMessage(hWndEdit, EM_STREAMIN, SF_TEXT|SF_UNICODE|SFF_SELECTION, (LPARAM)&es);
}

DWORD CALLBACK ReplaceSelCallbackW(DWORD dwCookie, LPBYTE pbBuff, LONG cb, LONG *pcb)
{
  PASTEDATA *lpData=(PASTEDATA *)dwCookie;
  wchar_t *pSrc=(wchar_t *)lpData->pData;
  wchar_t *pDest=(wchar_t *)pbBuff;
  int i;

  for (i=0, cb=cb / sizeof(wchar_t) - 1; i < cb && pSrc[lpData->nLength]; ++i)
  {
    pDest[i]=pSrc[lpData->nLength++];

    if (pDest[i] == '\r' && pSrc[lpData->nLength] != '\n')
      pDest[++i]='\n';
  }

  *pcb=i*sizeof(wchar_t);

  return 0;
}

wchar_t* GetSelTextW(HWND hWnd, CHARRANGE chrg)
{
  wchar_t *cb;
  int nLen=(chrg.cpMax - chrg.cpMin) + 1;
  int nLenW=nLen * sizeof(wchar_t);

  if (bOldRichEdit)
  {
    TEXTRANGE txtrng;
    int layout;

    if (cb=(wchar_t *)API_HeapAlloc(GetProcessHeap(), 0, nLenW + 2))
    {
      if (chrg.cpMax == chrg.cpMin)
      {
        cb[0]='\0';
        return cb;
      }
      if (txtrng.lpstrText=(char *)API_HeapAlloc(GetProcessHeap(), 0, nLen + 1))
      {
        layout=SetLayout();
        txtrng.chrg.cpMin=chrg.cpMin;
        txtrng.chrg.cpMax=chrg.cpMax;
        SendMessage(hWnd, EM_GETTEXTRANGE, 0, (LPARAM)&txtrng);
        RestoreLayout(layout);

        MultiByteToWideChar(CP_ACP, 0, txtrng.lpstrText, nLen, cb, nLen);
        HeapFree(GetProcessHeap(), 0, (LPVOID)txtrng.lpstrText);

        return cb;
      }
      HeapFree(GetProcessHeap(), 0, (LPVOID)cb);
    }
  }
  else
  {
    GETTEXTEX gt;

    if (cb=(wchar_t *)API_HeapAlloc(GetProcessHeap(), 0, nLenW + 2))
    {
      if (chrg.cpMax == chrg.cpMin)
      {
        cb[0]='\0';
        return cb;
      }
      gt.cb=nLenW;
      gt.flags=GT_SELECTION;
      gt.codepage=1200;
      gt.lpDefaultChar=NULL;
      gt.lpUsedDefChar=NULL;
      SendMessage(hWnd, EM_GETTEXTEX, (WPARAM)&gt, (LPARAM)cb);

      return cb;
    }
  }
  return NULL;
}

void FreeSelTextW(wchar_t *pText)
{
  if (pText) HeapFree(GetProcessHeap(), 0, (LPVOID)pText);
}


//// Go to line

BOOL CALLBACK GoToLineDlgProc(HWND hDlg, UINT uiMsg, WPARAM wParam, LPARAM lParam)
{
  static HWND hWndEdit;
  int line;
  int column;
  int linenumber;
  int newline;
  int newlinelen;

  switch(uiMsg)
  {
    case WM_INITDIALOG:
      SendMessage(hDlg, WM_SETICON, (WPARAM)ICON_BIG, (LPARAM)API_LoadIcon(hLangLib, MAKEINTRESOURCE(IDI_ICON)));
      hWndEdit=(HWND)lParam;

      line=SendMessage(hWndEdit, EM_EXLINEFROMCHAR, 0, nPosition)+1;
      SetDlgItemInt(hDlg, IDC_GOTOLINE, line, FALSE);
      return TRUE;

    case WM_COMMAND:
      switch(LOWORD(wParam))
      {
        case IDC_GOTOLINE:
          return TRUE;

        case IDOK:
          linenumber=GetDlgItemInt(hDlg, IDC_GOTOLINE, NULL, TRUE);

          if (!linenumber)
          {
            API_LoadString(hLangLib, MSG_WRONG_STRING, buf, BUFFER_SIZE);
            MessageBox(hDlg, buf, APP_SHORT_TITLE, MB_OK|MB_ICONERROR);
            return FALSE;
          }
          else if (linenumber < 0)
          {
            linenumber=SendMessage(hWndEdit, EM_GETLINECOUNT, 0, 0) + linenumber + 1;
            if (linenumber <= 0) linenumber=1;
          }

          line=SendMessage(hWndEdit, EM_EXLINEFROMCHAR, 0, nPosition)+1;
          column=SendMessage(hWndEdit, EM_LINEINDEX, line-1, 0);
          column=nPosition-column+1;
          newline=SendMessage(hWndEdit, EM_LINEINDEX, linenumber-1, 0);
          if (newline == -1) newline=SendMessage(hWndEdit, EM_LINEINDEX, SendMessage(hWndEdit, EM_GETLINECOUNT, 0, 0)-1, 0);
          newlinelen=SendMessage(hWndEdit, EM_LINELENGTH, newline, 0);

          if (column <= newlinelen) newline+=column-1;
          else newline+=newlinelen;
          SendMessage(hWndEdit, EM_SETSEL, newline, newline);

        case IDCANCEL:
          DestroyWindow(hDlg);
          hDlgModeless=NULL;
          return TRUE;
      }
  }
  return FALSE;
}


//// Recent files

void RecentFilesZero()
{
  if (szRecentNames) memset(szRecentNames, 0, nRecentFiles * MAX_PATH);
  if (szRecentPositions) memset(szRecentPositions, 0, nRecentFiles * sizeof(DWORD));
  if (szRecentCodepages) memset(szRecentCodepages, 0, nRecentFiles * sizeof(DWORD));
}

void RecentFilesRead()
{
  HKEY hKey;
  DWORD dwType, dwSize;
  int i;
  char szRegValue[16];

  //Read recent files array
  if (RegOpenKeyEx(HKEY_CURRENT_USER, "Software\\Akelsoft\\AkelPad\\Recent", 0, KEY_READ, &hKey) != ERROR_SUCCESS)
    return;

  for (i=0; i < nRecentFiles; ++i)
  {
    wsprintf(szRegValue, "name%d", i);
    dwSize=MAX_PATH;
    if (RegQueryValueEx(hKey, szRegValue, NULL, &dwType, (LPBYTE)szRecentNames[i], &dwSize) != ERROR_SUCCESS)
      break;

    wsprintf(szRegValue, "pos%d", i);
    dwSize=sizeof(DWORD);
    RegQueryValueEx(hKey, szRegValue, NULL, &dwType, (LPBYTE)&szRecentPositions[i], &dwSize);

    wsprintf(szRegValue, "cp%d", i);
    dwSize=sizeof(DWORD);
    RegQueryValueEx(hKey, szRegValue, NULL, &dwType, (LPBYTE)&szRecentCodepages[i], &dwSize);
  }
  RegCloseKey(hKey);
}

BOOL RecentFilesGet(char *file, int *position, int *codepage)
{
  int i;

  if (!*file) return FALSE;

  for (i=0; i < nRecentFiles; ++i)
    if (!lstrcmpi(szRecentNames[i], file))
    {
      if (position) *position=szRecentPositions[i];
      if (codepage) *codepage=szRecentCodepages[i];
      return TRUE;
    }

  return FALSE;
}

BOOL RecentFilesUpdate(char *file, int position, int codepage)
{
  int i;

  if (!*file) return FALSE;

  //Update recent files array - move/add current file to the first place
  for (i=0; i < nRecentFiles; ++i)
    if (!lstrcmpi(szRecentNames[i], file))
    {
      if (position == -1) position=szRecentPositions[i];
      if (codepage == -1) codepage=szRecentCodepages[i];
      ++i;
      break;
    }

  if (position == -1) position=0;
  if (codepage == -1) codepage=nDefaultCodePage;

  if (--i)
    for (; i >= 0; --i)
    {
      lstrcpy(szRecentNames[i], szRecentNames[i-1]);
      szRecentPositions[i]=szRecentPositions[i-1];
      szRecentCodepages[i]=szRecentCodepages[i-1];
    }

  lstrcpy(szRecentNames[0], file);
  szRecentPositions[0]=position;
  szRecentCodepages[0]=codepage;

  return TRUE;
}

int RecentFilesDeleteDead()
{
  int i;
  int a;
  int nDead=0;

  //Delete files from recent files array if they doesn't exist
  for (i=0; i < nRecentFiles && *szRecentNames[i]; ++i)
  {
    while (*szRecentNames[i] && !FileExists(szRecentNames[i]))
    {
      for (a=i; a < nRecentFiles-1; ++a)
      {
        lstrcpy(szRecentNames[a], szRecentNames[a+1]);
        szRecentPositions[a]=szRecentPositions[a+1];
        szRecentCodepages[a]=szRecentCodepages[a+1];
      }
      *szRecentNames[nRecentFiles-1]='\0';
      szRecentPositions[nRecentFiles-1]=0;
      szRecentCodepages[nRecentFiles-1]=0;
      ++nDead;
    }
  }
  return nDead;
}

void RecentFilesSave()
{
  char szRegValue[16];
  HKEY hKey;
  int i;

  //Save recent files array
  if (RegCreateKeyEx(HKEY_CURRENT_USER, "Software\\Akelsoft\\AkelPad\\Recent", 0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hKey, NULL) != ERROR_SUCCESS)
    return;

  for (i=0; i < nRecentFiles; ++i)
  {
    wsprintf(szRegValue, "name%d", i);
    RegSetValueEx(hKey, szRegValue, 0, REG_SZ, (LPBYTE)(*szRecentNames[i]?szRecentNames[i]:""), *szRecentNames[i]?lstrlen(szRecentNames[i])+1:1);

    wsprintf(szRegValue, "pos%d", i);
    RegSetValueEx(hKey, szRegValue, 0, REG_DWORD, (LPBYTE)&szRecentPositions[i], sizeof(DWORD));

    wsprintf(szRegValue, "cp%d", i);
    RegSetValueEx(hKey, szRegValue, 0, REG_DWORD, (LPBYTE)&szRecentCodepages[i], sizeof(DWORD));
  }
  RegCloseKey(hKey);
}

void RecentFilesMenu(HWND hWndEdit)
{
  int i;

  for (i=1; DeleteMenu(hMenu, IDM_RECENT_FILES+i, MF_BYCOMMAND); ++i);

  if (nRecentFiles && *szRecentNames[0])
  {
    API_LoadString(hLangLib, STR_RECENT_FILES_DELETE_DEAD, buf, BUFFER_SIZE);
    ModifyMenu(hMenu, IDM_RECENT_FILES, MF_BYCOMMAND|MF_STRING, IDM_RECENT_FILES, buf);

    for (i=0; *szRecentNames[i] && i < nRecentFiles; ++i)
    {
      TrimPath(buf, szRecentNames[i], RECENTFILES_RECORD_LENGTH);
      InsertMenu(hMenu, IDM_RECENT_FILES, MF_BYCOMMAND|MF_STRING, IDM_RECENT_FILES+i+1, buf);
    }
    InsertMenu(hMenu, IDM_RECENT_FILES, MF_BYCOMMAND|MF_SEPARATOR, IDM_RECENT_FILES+i+1, NULL);
  }
  else
  {
    API_LoadString(hLangLib, STR_RECENT_FILES_EMPTY, buf, BUFFER_SIZE);
    ModifyMenu(hMenu, IDM_RECENT_FILES, MF_BYCOMMAND|MF_STRING|MF_GRAYED, IDM_RECENT_FILES, buf);
  }
}

int TrimPath(char *szResult, char *pPath, int nMax)
{
  int filelen;
  int len=lstrlen(pPath);
  char *end=pPath + len;
  char *file=end - 1;

  if (len <= nMax)
  {
    lstrcpy(szResult, pPath);
    return len;
  }

  while (file >= pPath && *file != '\\') --file;

  if (file >= pPath)
  {
    filelen=end - file;

    if (nMax > filelen + 2)
    {
      lstrcpyn(szResult, pPath, nMax - filelen - 2);
      lstrcat(szResult, "...");
      lstrcat(szResult, file);
      return nMax;
    }
  }
  lstrcpy(szResult, "...");
  lstrcat(szResult, end - nMax + 3);
  return nMax;
}


//// Language menu

void LanguageMenu(HWND hWndEdit)
{
  WIN32_FIND_DATA wfd;
  HANDLE hFind;
  UINT uFlags;
  int i;
  nLangModules=0;

  for (i=1; DeleteMenu(hMenu, IDM_LANGUAGE+i, MF_BYCOMMAND); ++i);

  wsprintf(buf, "%s\\languages\\*.dll", szExeDir);

  if ((hFind=FindFirstFile(buf, &wfd)) != INVALID_HANDLE_VALUE)
  {
    i=1;

    do
    {
      if (!lstrcmpi(szLangModule, wfd.cFileName))
        uFlags=MF_BYCOMMAND|MF_STRING|MF_CHECKED;
      else
        uFlags=MF_BYCOMMAND|MF_STRING|MF_UNCHECKED;
      GetBaseName(wfd.cFileName, buf);
      InsertMenu(hMenu, IDM_LANGUAGE, uFlags, IDM_LANGUAGE+i, buf);
      ++i;
    }
    while (FindNextFile(hFind, &wfd));

    nLangModules=i-1;
    InsertMenu(hMenu, IDM_LANGUAGE, MF_BYCOMMAND|MF_SEPARATOR, IDM_LANGUAGE+i, NULL);
    FindClose(hFind);
  }

  API_LoadString(hLangLib, STR_LANGUAGE_NONE, buf, BUFFER_SIZE);
  if (!*szLangModule)
    uFlags=MF_BYCOMMAND|MF_STRING|MF_CHECKED;
  else
    uFlags=MF_BYCOMMAND|MF_STRING|MF_UNCHECKED;
  ModifyMenu(hMenu, IDM_LANGUAGE, uFlags, IDM_LANGUAGE, buf);
}

char* GetBaseName(char *pFile, char *szBaseName)
{
  int nStart=lstrlen(pFile);
  int nEnd=nStart;

  while (nStart > 0 && pFile[nStart] != '\\')
  {
    if (pFile[nStart] == '.') nEnd=nStart;
    --nStart;
  }
  if (pFile[nStart] == '\\') ++nStart;
  lstrcpyn(szBaseName, pFile + nStart, nEnd - nStart + 1);

  return szBaseName;
}


//// Word breaking

BOOL isInDelimiterList(wchar_t c)
{
  if (wcschr(wszDelimiters, c) != NULL)
    return TRUE;
  else
    return FALSE;
}

int CALLBACK EditWordBreakProc(LPTSTR pchText, int ichCurrent, int cch, int code)
{
  int lRet=0;
  wchar_t *pchTextW=(wchar_t *)pchText;
  int cchW=cch/sizeof(wchar_t);

  switch (code)
  {
    case WB_LEFTBREAK:
    case WB_MOVEWORDLEFT:
      // Finds the next character that begins a word before the specified position.
      {
        if (bFirstWordBreak)
        {
          do
            --ichCurrent;
          while (isInDelimiterList(pchTextW[ichCurrent]));
        }

        for (--ichCurrent; ichCurrent >= 0 && !isInDelimiterList(pchTextW[ichCurrent]); --ichCurrent);

        if (ichCurrent >= 0)
        {
          bFirstWordBreak=TRUE;
          lRet=ichCurrent+1;
        }
        else
        {
          bFirstWordBreak=FALSE;
          lRet=-1;
        }
      }
      break;
    case WB_MOVEWORDRIGHT:
      //Finds the next character that ends a word after the specified position.
      {
        if (bFirstWordBreak)
        {
          while (isInDelimiterList(pchTextW[ichCurrent]))
            ++ichCurrent;
          ++ichCurrent;
        }

        while (ichCurrent < cchW && !isInDelimiterList(pchTextW[ichCurrent]))
          ++ichCurrent;

        if (ichCurrent < cchW)
        {
          bFirstWordBreak=TRUE;
          lRet=ichCurrent;
        }
        else
        {
          bFirstWordBreak=FALSE;
          lRet=-1;
        }
      }
      break;
    case WB_CLASSIFY:
      //Retrieves the character class and word break flags of the character at the specified position.
      {
        if (!isInDelimiterList(pchTextW[ichCurrent]))
          lRet=WBF_ISWHITE; //WBF_BREAKAFTER|WBF_BREAKLINE;
        else
          lRet=-1;
      }
      break;
  }
  return lRet;
}


//// Options

BOOL CALLBACK OptionsDlgProc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
  static HWND hWndEdit;
  static HWND hWndCP;
  HWND hWndMarginLeft;
  HWND hWndMarginLeftSpin;
  HWND hWndMarginRight;
  HWND hWndMarginRightSpin;
  HWND hWndRecentFiles;
  HWND hWndRecentFilesSpin;
  HWND hWndRecentFilesClear;
  HWND hWndDelimiters;
  HWND hWndExecute;

  if (msg == WM_INITDIALOG)
  {
    SendMessage(hDlg, WM_SETICON, (WPARAM)ICON_BIG, (LPARAM)API_LoadIcon(hLangLib, MAKEINTRESOURCE(IDI_ICON)));
    hWndEdit=(HWND)lParam;
    hWndMarginLeft=GetDlgItem(hDlg, IDC_MARGIN_LEFT);
    hWndMarginLeftSpin=GetDlgItem(hDlg, IDC_MARGIN_LEFT_SPIN);
    hWndMarginRight=GetDlgItem(hDlg, IDC_MARGIN_RIGHT);
    hWndMarginRightSpin=GetDlgItem(hDlg, IDC_MARGIN_RIGHT_SPIN);
    hWndRecentFiles=GetDlgItem(hDlg, IDC_RECENTFILES_AMOUNT);
    hWndRecentFilesSpin=GetDlgItem(hDlg, IDC_RECENTFILES_AMOUNT_SPIN);
    hWndRecentFilesClear=GetDlgItem(hDlg, IDC_RECENTFILES_CLEAR);
    hWndDelimiters=GetDlgItem(hDlg, IDC_DELIMITERS);
    hWndExecute=GetDlgItem(hDlg, IDC_EXEC);
    hWndCP=GetDlgItem(hDlg, IDC_CODEPAGE);

    SendMessage(hWndDelimiters, EM_LIMITTEXT, (WPARAM)DELIMITERS_SIZE, 0);
    SendMessage(hWndExecute, EM_LIMITTEXT, (WPARAM)BUFFER_SIZE, 0);
    SendMessage(hWndMarginLeftSpin, UDM_SETBUDDY, (WPARAM)hWndMarginLeft, 0);
    SendMessage(hWndMarginRightSpin, UDM_SETBUDDY, (WPARAM)hWndMarginRight, 0);
    SendMessage(hWndRecentFilesSpin, UDM_SETBUDDY, (WPARAM)hWndRecentFiles, 0);
    SendMessage(hWndMarginLeftSpin, UDM_SETRANGE, 0, (LPARAM)MAKELONG(999, 0));
    SendMessage(hWndMarginRightSpin, UDM_SETRANGE, 0, (LPARAM)MAKELONG(999, 0));
    SendMessage(hWndRecentFilesSpin, UDM_SETRANGE, 0, (LPARAM)MAKELONG(999, 0));

    SetDlgItemInt(hDlg, IDC_MARGIN_LEFT, LOWORD(dwEditMargins), FALSE);
    SetDlgItemInt(hDlg, IDC_MARGIN_RIGHT, HIWORD(dwEditMargins), FALSE);
    SetDlgItemInt(hDlg, IDC_RECENTFILES_AMOUNT, nRecentFiles, FALSE);
    if (!nRecentFiles || !*szRecentNames[0]) EnableWindow(hWndRecentFilesClear, FALSE);

    EscapeDataToEscapeStringW(wszDelimiters, (wchar_t *)buf);
    WideCharToMultiByte(CP_ACP, 0, (wchar_t *)buf, -1, buf2, BUFFER_SIZE, NULL, NULL);
    SetWindowText(hWndDelimiters, buf2);
    SetWindowText(hWndExecute, szCommand);

    FillComboboxCodepage(hWndCP);
    SelectComboboxCodepage(hWndCP, nDefaultCodePage);
  }
  else if (msg == WM_COMMAND)
  {
    if (LOWORD(wParam) == IDC_RECENTFILES_CLEAR)
    {
      RecentFilesZero();
      RecentFilesSave();
      RecentFilesMenu(hWndEdit);
      EnableWindow((HWND)lParam, FALSE);
    }
    else if (LOWORD(wParam) == IDC_EXEC_BROWSE)
    {
      OPENFILENAME efn={0};

      buf[0]='\0';
      efn.lStructSize      =sizeof(OPENFILENAME);
      efn.hwndOwner        =hDlg;
      efn.lpstrFile        =(char *)&buf;
      efn.nMaxFile         =MAX_PATH;
      efn.lpstrFilter      ="Executable files (*.exe)\0*.exe\0All files (*.*)\0*.*";
      efn.nFilterIndex     =1;
      efn.Flags            =OFN_HIDEREADONLY|OFN_PATHMUSTEXIST;

      if (GetOpenFileName(&efn))
      {
        wsprintf(buf2, "\"%s\"", buf);
        SetDlgItemText(hDlg, IDC_EXEC, buf2);
      }
    }
    else if (LOWORD(wParam) == IDC_DEFAULT)
    {
      SetDlgItemInt(hDlg, IDC_MARGIN_LEFT, LOWORD(EDIT_MARGINS), FALSE);
      SetDlgItemInt(hDlg, IDC_MARGIN_RIGHT, HIWORD(EDIT_MARGINS), FALSE);
      SetDlgItemInt(hDlg, IDC_RECENTFILES_AMOUNT, RECENTFILES_AMOUNT, FALSE);

      EscapeDataToEscapeStringW(WORD_DELIMITERSW, (wchar_t *)buf);
      WideCharToMultiByte(CP_ACP, 0, (wchar_t *)buf, -1, buf2, BUFFER_SIZE, NULL, NULL);
      SetDlgItemText(hDlg, IDC_DELIMITERS, buf2);
      SetDlgItemText(hDlg, IDC_EXEC, "");

      SelectComboboxCodepage(hWndCP, nAnsiCodePage);
    }
    else if (LOWORD(wParam) == IDOK)
    {
      HKEY hKey;
      int a;
      int b;

      //Margins
      a=GetDlgItemInt(hDlg, IDC_MARGIN_LEFT, NULL, FALSE);
      b=GetDlgItemInt(hDlg, IDC_MARGIN_RIGHT, NULL, FALSE);
      if (dwEditMargins != (DWORD)MAKELONG(a, b))
        dwEditMargins=MAKELONG(a, b);

      //Recent files
      a=GetDlgItemInt(hDlg, IDC_RECENTFILES_AMOUNT, NULL, FALSE);
      if (nRecentFiles != a)
      {
        nRecentFiles=a;
        FreeMemoryRecentFiles();

        if (nRecentFiles)
        {
          if ((szRecentNames=(char (*)[MAX_PATH])API_HeapAlloc(GetProcessHeap(), 0, nRecentFiles * MAX_PATH)) &&
              (szRecentPositions=(DWORD *)API_HeapAlloc(GetProcessHeap(), 0, nRecentFiles * sizeof(DWORD))) &&
              (szRecentCodepages=(DWORD *)API_HeapAlloc(GetProcessHeap(), 0, nRecentFiles * sizeof(DWORD))))
          {
            RecentFilesZero();
            RecentFilesRead();
          }
        }
        RecentFilesMenu(hWndEdit);

        if (RegOpenKeyEx(HKEY_CURRENT_USER, "Software\\Akelsoft\\AkelPad", 0, KEY_ENUMERATE_SUB_KEYS, &hKey) == ERROR_SUCCESS)
        {
          RegDeleteKey(hKey, "Recent");
          RegCloseKey(hKey);
          RecentFilesSave();
        }
      }

      //Word delimiters
      a=GetDlgItemText(hDlg, IDC_DELIMITERS, buf, BUFFER_SIZE);
      MultiByteToWideChar(CP_ACP, 0, buf, ++a, (wchar_t *)buf2, BUFFER_SIZE / sizeof(wchar_t));
      EscapeStringToEscapeDataW((wchar_t *)buf2, wszDelimiters);

      //Execute command
      GetDlgItemText(hDlg, IDC_EXEC, szCommand, BUFFER_SIZE);

      //Default codepage
      nDefaultCodePage=GetComboboxCodepage(hWndCP);

      EndDialog(hDlg, 0);
      return TRUE;
    }
    else if (LOWORD(wParam) == IDCANCEL)
    {
      EndDialog(hDlg, 0);
      return TRUE;
    }
  }

  return FALSE;
}


//// About

BOOL CALLBACK AboutDlgProc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
  if (msg == WM_INITDIALOG)
  {
    SendMessage(hDlg, WM_SETICON, (WPARAM)ICON_BIG, (LPARAM)API_LoadIcon(hLangLib, MAKEINTRESOURCE(IDI_ICON)));
    SetDlgItemText(hDlg, IDC_ABOUT_VERSION, APP_ABOUT_VERSION);
    SetDlgItemText(hDlg, IDC_HOMEPAGE, APP_HOMEPAGE);
    SetDlgItemText(hDlg, IDC_ABOUT_EMAIL_KUZNETSOV, APP_ABOUT_EMAIL_KUZNETSOV);
    SetDlgItemText(hDlg, IDC_ABOUT_ICQ_KUZNETSOV, APP_ABOUT_ICQ_KUZNETSOV);
    SetDlgItemText(hDlg, IDC_ABOUT_EMAIL_SHENGALTS, APP_ABOUT_EMAIL_SHENGALTS);
  }
  else if (msg == WM_COMMAND)
  {
    if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
    {
      EndDialog(hDlg, 0);
      return TRUE;
    }
    else if (LOWORD(wParam) == IDC_HOMEPAGE)
    {
      ShellExecute(GetParent(hDlg), "open", APP_HOMEPAGE, NULL, NULL, SW_MAXIMIZE);
    }
  }
  return FALSE;
}


//// Other functions

char* GetCommandLineParamsA()
{
  char *lpCmdLine=GetCommandLine();

  if (*lpCmdLine++ == '\"')
    while (*lpCmdLine != '\"' && *lpCmdLine != '\0') ++lpCmdLine;
  else
    while (*lpCmdLine != ' ' && *lpCmdLine != '\0') ++lpCmdLine;
  if (*lpCmdLine != '\0')
    while (*++lpCmdLine == ' ');

  return lpCmdLine;
}

int GetCommandLineArgA(char *lpCmdLine, char *szArg, char **lpNextArg)
{
  char *pCount=lpCmdLine;
  char *pArg=szArg;

  while (*pCount == ' ')
    ++pCount;

  while (*pCount != '\0' && *pCount != ' ')
  {
    for (; *pCount != '\"' && *pCount != ' ' && *pCount != '\0'; ++pArg, ++pCount)
      if (szArg) *pArg=*pCount;

    if (*pCount == '\"')
    {
      for (++pCount; *pCount != '\"' && *pCount != '\0'; ++pArg, ++pCount)
        if (szArg) *pArg=*pCount;
      if (*pCount == '\"') ++pCount;
    }
  }
  if (szArg) *pArg='\0';

  if (lpNextArg)
    for (*lpNextArg=pCount; **lpNextArg == ' '; ++*lpNextArg);

  return (pArg - szArg);
}

BOOL SaveChanged(HWND hWndEdit)
{
  int nChoice;

  if (bModified)
  {
    API_LoadString(hLangLib, MSG_DOCUMENT_CHANGED, buf, BUFFER_SIZE);
    nChoice=MessageBox(hMainWnd, buf, APP_SHORT_TITLE, MB_YESNOCANCEL|MB_ICONEXCLAMATION);

    if (nChoice == IDYES)
    {
      if (!DoFileSave(hWndEdit)) return FALSE;
    }
    else if (nChoice == IDCANCEL) return FALSE;
  }
  return TRUE;
}

int SetLayout()
{
  int reserv_layout=LOWORD(GetKeyboardLayout(0));
  if (reserv_layout != wSystemLanguage && !ActivateKeyboardLayout((HKL)wSystemLanguage, 0))
    reserv_layout=0;
  return reserv_layout;
}

void RestoreLayout(int reserv_layout)
{
  if (reserv_layout) ActivateKeyboardLayout((HKL)reserv_layout, 0);
}

void SetChosenFont(HWND hWndEdit)
{
  CHARFORMAT cfmt;

  cfmt.cbSize=sizeof(CHARFORMAT);
  cfmt.dwMask=CFM_SIZE|CFM_CHARSET|CFM_FACE|CFM_BOLD|CFM_ITALIC|CFM_UNDERLINE|CFM_STRIKEOUT;
  cfmt.yHeight=PixelsToTwips(hWndEdit, logfont.lfHeight);
  cfmt.bCharSet=logfont.lfCharSet;
  cfmt.bPitchAndFamily=logfont.lfPitchAndFamily;
  lstrcpy(cfmt.szFaceName, logfont.lfFaceName);
  cfmt.dwEffects=0;
  if (logfont.lfWeight >= FW_BOLD)
    cfmt.dwEffects|=CFE_BOLD;
  if (logfont.lfItalic)
    cfmt.dwEffects|=CFE_ITALIC;
  if (logfont.lfUnderline)
    cfmt.dwEffects|=CFE_UNDERLINE;
  if (logfont.lfStrikeOut)
    cfmt.dwEffects|=CFE_STRIKEOUT;

  SendMessage(hWndEdit, EM_SETCHARFORMAT, SCF_ALL, (LPARAM)&cfmt);
}

void SetChosenFontColor(HWND hWndEdit)
{
  CHARFORMAT cfmt;

  cfmt.cbSize=sizeof(CHARFORMAT);
  cfmt.dwMask=CFM_COLOR;
  cfmt.dwEffects=0;
  cfmt.crTextColor=crFont;

  SendMessage(hWndEdit, EM_SETCHARFORMAT, SCF_ALL, (LPARAM)&cfmt);
}

void SetChosenFontSize(HWND hWndEdit)
{
  CHARFORMAT cfmt;

  cfmt.cbSize=sizeof(CHARFORMAT);
  cfmt.dwMask=CFM_SIZE;
  cfmt.yHeight=PixelsToTwips(hWndEdit, logfont.lfHeight);

  SendMessage(hWndEdit, EM_SETCHARFORMAT, SCF_ALL, (LPARAM)&cfmt);
}

int PixelsToTwips(HWND hWndEdit, int nPixels)
{
  HDC hDC;
  int nTwips;

  hDC=GetDC(hWndEdit);
  if (nPixels < 0) nPixels=0 - nPixels;
  nTwips=nPixels*72*20/GetDeviceCaps(hDC, LOGPIXELSY);
  ReleaseDC(hWndEdit, hDC);

  return nTwips;
}

void SetModify(BOOL state)
{
  bModified=state;
  API_LoadString(hLangLib, STR_MODIFIED, buf, BUFFER_SIZE);
  SendMessage(hStatus, SB_SETTEXT, 1, (LPARAM)(bModified?buf:""));
}

void SetInsertState(BOOL state)
{
  bInsertstate=state;
  SendMessage(hStatus, SB_SETTEXT, 2, (LPARAM)(bInsertstate?"Ins":"Ovr"));
}

void SetUnixNewLine(BOOL state)
{
  bUnixNewLine=state;
  SendMessage(hStatus, SB_SETTEXT, 3, (LPARAM)(bUnixNewLine?"Unix":"Win"));
}

BOOL FileExists(char *fname)
{
  WIN32_FIND_DATA wfd;
  HANDLE hFind;

  if ((hFind=FindFirstFile(fname, &wfd)) == INVALID_HANDLE_VALUE)
    return FALSE;

  FindClose(hFind);
  return TRUE;
}

int IsFile(char *fname)
{
  WIN32_FIND_DATA wfd;
  HANDLE hFind;

  if ((hFind=FindFirstFile(fname, &wfd)) == INVALID_HANDLE_VALUE)
    return ERROR_INVALID_HANDLE;

  if (wfd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
    return ERROR_FILE_NOT_FOUND;

  FindClose(hFind);
  return ERROR_SUCCESS;
}


void GetFileVersion(char *pFile, int *nMajor, int *nMinor, int *nRelease, int *nBuild)
{
 DWORD dwHandle;
 DWORD dwVerSize;
 void *pVerBuf;
 UINT uLen;
 VS_FIXEDFILEINFO ffi;
 VS_FIXEDFILEINFO *pffi=&ffi;
 *nMajor=*nMinor=*nRelease=*nBuild=0;

 if (dwVerSize=GetFileVersionInfoSize(pFile, &dwHandle))
 {
  if (pVerBuf=GlobalAlloc(GPTR, dwVerSize))
  {
   if (GetFileVersionInfo(pFile, dwHandle, dwVerSize, pVerBuf) && VerQueryValue(pVerBuf, "\\", (void **)&pffi, &uLen))
   {
     *nMajor=pffi->dwFileVersionMS / 0x00010000;
     *nMinor=pffi->dwFileVersionMS & 0x0000FFFF;
     *nRelease=pffi->dwFileVersionLS / 0x00010000;
     *nBuild=pffi->dwFileVersionLS & 0x0000FFFF;
   }
   GlobalFree(pVerBuf);
  }
 }
}

int ParseExecCommand(char *pCommand, char *szBuffer, int nBufferSize)
{
  //%f == szCurrentFile, %e == szExeDir, %% == %
  int a;
  int b;
  char *pFile=szCurrentFile;
  char *pExeDir=szExeDir;
  int nFileLen=lstrlen(pFile);
  int nExeDirLen=lstrlen(pExeDir);

  for (a=0, b=0; pCommand[a] && (!szBuffer || b < nBufferSize); ++a, ++b)
  {
    if (pCommand[a] == '%')
    {
      if (pCommand[++a] == '%')
      {
        if (szBuffer) szBuffer[b]='%';
      }
      else if (pCommand[a] == 'f' || pCommand[a] == 'F')
      {
        if (!szBuffer || b + nFileLen <= nBufferSize)
        {
          if (szBuffer) lstrcpy(szBuffer + b, pFile);
          b+=nFileLen - 1;
        }
        else break;
      }
      else if (pCommand[a] == 'e' || pCommand[a] == 'E')
      {
        if (!szBuffer || b + nExeDirLen <= nBufferSize)
        {
          if (szBuffer) lstrcpy(szBuffer + b, pExeDir);
          b+=nExeDirLen - 1;
        }
        else break;
      }
      else break;
    }
    else if (szBuffer) szBuffer[b]=pCommand[a];
  }
  if (szBuffer && b < nBufferSize) szBuffer[b]='\0';
  return b;
}

void FreeMemorySearch()
{
  if (wszSearch_orig)
  {
    HeapFree(GetProcessHeap(), 0, (LPVOID)wszSearch_orig);
    if (wszSearch_orig == wszSearch)
      wszSearch=NULL;
    wszSearch_orig=NULL;
  }
  if (wszReplace_orig)
  {
    HeapFree(GetProcessHeap(), 0, (LPVOID)wszReplace_orig);
    if (wszReplace_orig == wszReplace)
      wszReplace=NULL;
    wszReplace_orig=NULL;
  }

  if (wszSearch)
  {
    HeapFree(GetProcessHeap(), 0, (LPVOID)wszSearch);
    wszSearch=NULL;
  }
  if (wszReplace)
  {
    HeapFree(GetProcessHeap(), 0, (LPVOID)wszReplace);
    wszReplace=NULL;
  }
}

void FreeMemoryRecentFiles()
{
  if (szRecentNames)
  {
    HeapFree(GetProcessHeap(), 0, (LPVOID)szRecentNames);
    szRecentNames=NULL;
  }
  if (szRecentPositions)
  {
    HeapFree(GetProcessHeap(), 0, (LPVOID)szRecentPositions);
    szRecentPositions=NULL;
  }
  if (szRecentCodepages)
  {
    HeapFree(GetProcessHeap(), 0, (LPVOID)szRecentCodepages);
    szRecentCodepages=NULL;
  }
}


//// API functions replacement

HMENU API_LoadMenu(HINSTANCE hLoadInstance, LPCTSTR lpMenuName)
{
  HMENU hResult;

  if (!(hResult=LoadMenu(hLoadInstance, lpMenuName)))
    if (hLoadInstance != hInstance)
      hResult=LoadMenu(hInstance, lpMenuName);

  return hResult;
}

HACCEL API_LoadAccelerators(HINSTANCE hLoadInstance, LPCTSTR lpTableName)
{
  HACCEL hResult;

  if (!(hResult=LoadAccelerators(hLoadInstance, lpTableName)))
    if (hLoadInstance != hInstance)
      hResult=LoadAccelerators(hInstance, lpTableName);

  return hResult;
}

HCURSOR API_LoadCursor(HINSTANCE hLoadInstance, LPCTSTR lpCursorName)
{
  HCURSOR hResult;

  if (!(hResult=LoadCursor(hLoadInstance, lpCursorName)))
    if (hLoadInstance != hInstance)
      hResult=LoadCursor(hInstance, lpCursorName);

  return hResult;
}

HICON API_LoadIcon(HINSTANCE hLoadInstance, LPCTSTR lpIconName)
{
  HICON hResult;

  if (!(hResult=LoadIcon(hLoadInstance, lpIconName)))
    if (hLoadInstance != hInstance)
      hResult=LoadIcon(hInstance, lpIconName);

  return hResult;
}

int API_LoadString(HINSTANCE hLoadInstance, UINT uID, LPTSTR lpBuffer, int nBufferMax)
{
  int nResult;

  if (!(nResult=LoadString(hLoadInstance, uID, lpBuffer, nBufferMax)))
    if (hLoadInstance != hInstance)
      if (!(nResult=LoadString(hInstance, uID, lpBuffer, nBufferMax)))
        lpBuffer[0]='\0';

  return nResult;
}

HWND API_CreateDialogParamA(HINSTANCE hLoadInstance, LPCTSTR lpTemplateName, HWND hWndParent, DLGPROC lpDialogFunc, LPARAM dwInitParam)
{
  HWND hResult;

  if (!(hResult=CreateDialogParamA(hLoadInstance, lpTemplateName, hWndParent, lpDialogFunc, dwInitParam)))
    if (hLoadInstance != hInstance)
      hResult=CreateDialogParamA(hInstance, lpTemplateName, hWndParent, lpDialogFunc, dwInitParam);

  return hResult;
}

HWND API_CreateDialogParamW(HINSTANCE hLoadInstance, LPCWSTR lpTemplateName, HWND hWndParent, DLGPROC lpDialogFunc, LPARAM dwInitParam)
{
  HWND hResult;

  if (!(hResult=CreateDialogParamW(hLoadInstance, lpTemplateName, hWndParent, lpDialogFunc, dwInitParam)))
    if (hLoadInstance != hInstance)
      hResult=CreateDialogParamW(hInstance, lpTemplateName, hWndParent, lpDialogFunc, dwInitParam);

  return hResult;
}

LPVOID API_HeapAlloc(HANDLE hHeap, DWORD dwFlags, SIZE_T dwBytes)
{
  LPVOID lpResult;

  if (!(lpResult=HeapAlloc(hHeap, dwFlags, dwBytes)))
  {
    API_LoadString(hLangLib, MSG_ERROR_NOT_ENOUGH_MEMORY, buf, BUFFER_SIZE);
    MessageBox(hMainWnd, buf, APP_SHORT_TITLE, MB_OK|MB_ICONERROR);
  }

  return lpResult;
}

HANDLE API_CreateFile(LPCTSTR lpFileName, DWORD dwDesiredAccess, DWORD dwShareMode, LPSECURITY_ATTRIBUTES lpSecurityAttributes, DWORD dwCreationDisposition, DWORD dwFlagsAndAttributes, HANDLE hTemplateFile)
{
  HANDLE hResult;

  if ((hResult=CreateFile(lpFileName, dwDesiredAccess, dwShareMode, lpSecurityAttributes, dwCreationDisposition, dwFlagsAndAttributes, hTemplateFile)) == INVALID_HANDLE_VALUE)
  {
    API_LoadString(hLangLib, MSG_ERROR_CANNOT_OPEN_FILE, buf, BUFFER_SIZE);
    MessageBox(hMainWnd, buf, APP_SHORT_TITLE, MB_OK|MB_ICONERROR);
  }

  return hResult;
}

BOOL API_ReadFile(HANDLE hFile, LPVOID lpBuffer, DWORD nNumberOfBytesToRead, LPDWORD lpNumberOfBytesRead, LPOVERLAPPED lpOverlapped)
{
  BOOL bResult;

  if (!(bResult=ReadFile(hFile, lpBuffer, nNumberOfBytesToRead, lpNumberOfBytesRead, lpOverlapped)))
  {
    API_LoadString(hLangLib, MSG_ERROR_IO, buf, BUFFER_SIZE);
    MessageBox(hMainWnd, buf, APP_SHORT_TITLE, MB_OK|MB_ICONERROR);
  }

  return bResult;
}

BOOL API_WriteFile(HANDLE hFile, LPCVOID lpBuffer, DWORD nNumberOfBytesToWrite, LPDWORD lpNumberOfBytesWritten, LPOVERLAPPED lpOverlapped)
{
  BOOL bResult;

  if (!(bResult=WriteFile(hFile, lpBuffer, nNumberOfBytesToWrite, lpNumberOfBytesWritten, lpOverlapped)))
  {
    API_LoadString(hLangLib, MSG_ERROR_IO, buf, BUFFER_SIZE);
    MessageBox(hMainWnd, buf, APP_SHORT_TITLE, MB_OK|MB_ICONERROR);
  }

  return bResult;
}

BOOL API_SetWindowTextW(HWND hWnd, LPCWSTR lpString)
{
  BOOL bResult=FALSE;
  char *pData;
  int nLenW;

  if (!bUnicode)
  {
    nLenW=wcslen(lpString) + 1;

    if (pData=(char *)API_HeapAlloc(GetProcessHeap(), 0, nLenW + 1))
    {
      WideCharToMultiByte(CP_ACP, 0, lpString, nLenW, pData, nLenW, NULL, NULL);
      bResult=SetWindowText(hWnd, pData);
      HeapFree(GetProcessHeap(), 0, (LPVOID)pData);
    }
  }
  else
    bResult=SetWindowTextW(hWnd, lpString);

  return bResult;
}

BOOL API_GetWindowTextLengthW(HWND hWnd)
{
  BOOL bResult;

  if (!bUnicode)
    bResult=GetWindowTextLength(hWnd);
  else
    bResult=GetWindowTextLengthW(hWnd);

  return bResult;
}

int API_GetWindowTextW(HWND hWnd, LPWSTR lpString, int nMaxCount)
{
  int nResult;
  char *pData;

  if (!bUnicode)
  {
    if (pData=(char *)API_HeapAlloc(GetProcessHeap(), 0, nMaxCount + 1))
    {
      nResult=GetWindowText(hWnd, pData, nMaxCount);
      MultiByteToWideChar(CP_ACP, 0, pData, nMaxCount, lpString, nMaxCount);
      HeapFree(GetProcessHeap(), 0, (LPVOID)pData);
    }
  }
  else
    nResult=GetWindowTextW(hWnd, lpString, nMaxCount);

  return nResult;
}

int API_lstrlenW(LPCWSTR lpString)
{
  int nResult;

  if (!bUnicode)
    nResult=wcslen(lpString);
  else
    nResult=lstrlenW(lpString);

  return nResult;
}

int API_lstrcmpW(LPCWSTR lpString1, LPCWSTR lpString2)
{
  int nResult;

  if (!bUnicode)
    nResult=wcscmp(lpString1, lpString2);
  else
    nResult=lstrcmpW(lpString1, lpString2);

  return nResult;
}

int API_lstrcmpiW(LPCWSTR lpString1, LPCWSTR lpString2)
{
  int nResult=0;
  char *pData1;
  char *pData2;
  int nLen1;
  int nLen2;

  if (!bUnicode)
  {
    nLen1=wcslen(lpString1) + 1;
    nLen2=wcslen(lpString2) + 1;

    if (pData1=(char *)API_HeapAlloc(GetProcessHeap(), 0, nLen1 + 1))
    {
      if (pData2=(char *)API_HeapAlloc(GetProcessHeap(), 0, nLen2 + 1))
      {
        WideCharToMultiByte(CP_ACP, 0, lpString1, nLen1, pData1, nLen1, NULL, NULL);
        WideCharToMultiByte(CP_ACP, 0, lpString2, nLen2, pData2, nLen2, NULL, NULL);
        nResult=lstrcmpi(pData1, pData2);
        HeapFree(GetProcessHeap(), 0, (LPVOID)pData2);
      }
      HeapFree(GetProcessHeap(), 0, (LPVOID)pData1);
    }
  }
  else
    nResult=lstrcmpiW(lpString1, lpString2);

  return nResult;
}
