#ifndef __EDIT_H__
#define __EDIT_H__

#define APP_SHORT_TITLE            "AkelPad"
#define APP_FULL_TITLE             "AkelPad3"
#define APP_DUMMY_NAME             "AkelPad Synchronizing Class"
#define APP_ABOUT_VERSION          "AkelPad 3.0.0 beta 3"
#define APP_HOMEPAGE               "http://akelpad.sf.net"
#define APP_ABOUT_EMAIL_KUZNETSOV  "developer@akelpad.net.ru"
#define APP_ABOUT_ICQ_KUZNETSOV    "109590531"
#define APP_ABOUT_EMAIL_SHENGALTS  "shengalts@mail.ru"

//Code pages strings
#define STR_SYSTEM_ANSI     "ANSI  (Windows)"
#define STR_SYSTEM_OEM      "OEM  (DOS)"
#define STR_UNICODE_UCS2_LE "1200  (UTF-16 LE)"
#define STR_UNICODE_UCS2_BE "1201  (UTF-16 BE)"
#define STR_UNICODE_UTF8    "65001 (UTF-8)"

//Code pages int
#define CP_UNICODE_UCS2_LE  1200
#define CP_UNICODE_UCS2_BE  1201
#define CP_UNICODE_UTF8     65001
#define CP_KOI8_R           20866

#ifndef IMF_AUTOFONTSIZEADJUST
  #define IMF_AUTOFONTSIZEADJUST 0x0010
#endif
#ifndef GT_SELECTION
  #define GT_SELECTION 2
#endif
#ifndef PFN_ARABIC
  #define PFN_ARABIC 2
#endif
#ifndef PFN_UCLETTER
  #define PFN_UCLETTER 4
#endif
#ifndef PFN_UCROMAN
  #define PFN_UCROMAN 6
#endif
#ifndef PFNS_PAREN
  #define PFNS_PAREN 0x000
#endif
#ifndef WM_MOUSEWHEEL
  #define WM_MOUSEWHEEL  0x020A
#endif

#define BUFFER_SIZE                1024
#define TRANSLATE_BUFFER_SIZE      8192
#define PREVIEW_SIZE               8188  //4094*2; -1 preview all file
#define DELIMITERS_SIZE            128
#define DETECTBINARY               128
#define DETECTBOM                  4
#define RECENTFILES_AMOUNT         10
#define RECENTFILES_RECORD_LENGTH  90
#define EDIT_MARGINS               MAKELONG(4, 4)
#define WORD_DELIMITERSW          L" \t\r\\|[](){}<>,.;:+-=~!@#$%^&*/?'`\""
#define SENTENCE_SELIMITERS        "."
#define TITLE_DELIMITERS           " \t\r"

//Autodetect flags
#define ADT_BINARY_ERROR      0x00000001
#define ADT_REG_CODEPAGE      0x00000002
#define ADT_DETECT_CODEPAGE   0x00000004
#define ADT_DETECT_BOM        0x00000008

//Autodetect errors
#define EDT_BYTESTOCHECK  -1
#define EDT_FLAGS         -2
#define EDT_OPEN          -3
#define EDT_ALLOC         -4
#define EDT_READ          -5
#define EDT_BINARY        -6

//Search/Replace options
#define FR_UP           0x00000008
#define FR_BEGINNING    0x00000010
#define FR_SELECTION    0x00000020
#define FR_ESCAPESEQ    0x00000040

//Selection case
#define UPPERCASE    1
#define LOWERCASE    2
#define SENTENCECASE 3
#define TITLECASE    4
#define INVERTCASE   5

//Insert/Delete char in selection
#define CHECK_STATE                 1
#define CHAR_INSERT                 2
#define CHAR_DELETE                 3

//Delete trailing whitespaces in selection
#define CHECK_TRAILING_WHITESPACES  1
#define DELETE_TRAILING_WHITESPACES 2

//Change font size
#define DECREASE_FONT 1
#define INCREASE_FONT 2

void InitEditor(HWND);

BOOL DoFileNew(HWND hWndEdit);
void DoFileNewWindow(HWND hWndEdit);
BOOL DoFileOpen(HWND hWndEdit);
void DoFileReopenAs(HWND hWndEdit, int nCodePage, BOOL bBOM);
BOOL DoFileSave(HWND hWndEdit);
BOOL DoFileSaveAs(HWND hWndEdit);
void DoFilePageSetup(HWND hWndEdit);
void DoFilePrint(HWND hWndEdit);
BOOL DoFileExit(HWND hWndEdit);
void DoEditUndo(HWND hWndEdit);
void DoEditRedo(HWND hWndEdit);
void DoEditCut(HWND hWndEdit);
void DoEditCopy(HWND hWndEdit);
void DoEditPaste(HWND hWndEdit);
void DoEditPasteANSI(HWND hWndEdit);
void DoEditClear(HWND hWndEdit);
void DoEditSelectAll(HWND hWndEdit);
void DoEditInsertChar(HWND hWndEdit);
BOOL DoEditInsertCharInSelection(HWND hWndEdit, int nAction, char ch);
BOOL DoEditDeleteTrailingWhitespaces(HWND hWndEdit, int nAction);
void DoEditChangeCase(HWND hWndEdit, int nCase);
void DoSearchFind(HWND hWndEdit);
void DoSearchFindNextDown(HWND hWndEdit);
void DoSearchFindNextUp(HWND hWndEdit);
void DoSearchReplace(HWND hWndEdit);
void DoSearchGoToLine(HWND hWndEdit);
void DoViewFont(HWND hWndEdit);
void DoViewTextColor(HWND hWndEdit);
void DoViewBGColor(HWND hWndEdit);
void DoViewFontSize(HWND hWndEdit, int nAction);
void DoViewAlignment(HWND hWndEdit, WORD wAlignment);
void DoViewNumbering(HWND hWndEdit, WORD wNumbering);
void DoViewOnTop(HWND hWndEdit, BOOL bBool);
void DoViewWordWrap(HWND hWndEdit, BOOL bBool);
void DoViewShowStatusBar(HWND hWndEdit, BOOL bBool);
void DoSettingsExec(char *pCommand);
void DoSettingsSaveTime(HWND hWndEdit, BOOL bBool);
void DoSettingsSingleOpen(HWND hWndEdit, BOOL bBool);
void DoSettingsKeepSpace(HWND hWndEdit, BOOL bBool);
void DoSettingsOptions(HWND hWndEdit);
void DoHelpAbout(HWND hWndEdit);
void DoNonMenuDelLine(HWND hWndEdit);

BOOL ReadOptionsFromRegistry();
BOOL SaveOptionsInRegistry(HWND hWnd);

BOOL OpenDocument(HWND hWndEdit, char *szFile, int nCodePage, int nBOM);
DWORD CALLBACK InputStreamCallbackW(DWORD dwCookie, LPBYTE pbBuff, LONG cb, LONG *pcb);
BOOL SaveDocument(HWND hWndEdit, char *szFile, int nCodePage, BOOL bBOM);
DWORD CALLBACK OutputStreamCallbackW(DWORD dwCookie, LPBYTE pbBuff, LONG cb, LONG *pcb);

unsigned int CALLBACK CodePageDlgProc(HWND hDlg, UINT uiMsg, WPARAM wParam, LPARAM lParam);
void FillComboboxCodepage(HWND hWnd);
BOOL RegEnumCodePages(int *codepages, int size);
int GetComboboxCodepage(HWND hWnd);
int SelectComboboxCodepage(HWND hWnd, int nCodepage);
int FilePreview(HWND hWnd, char *pFile, int nPreviewBytes, DWORD Flags, int *nCodePage, BOOL *bBOM);
int AutodetectCodePage(char *pFile, DWORD dwBytesToCheck, DWORD Flags, int *nCodePage, BOOL *bBOM);
BOOL DisplayCodePage(int cp);
unsigned int UTF8toUTF16(const char *buf, unsigned int *len, wchar_t *tbuf, unsigned int tlen);
unsigned int UTF16toUTF8(const wchar_t *tbuf, unsigned int tlen, char *buf, unsigned int len);
void ChangeByteOrder(unsigned char *buf, unsigned int len);
int getmaxelement(int *base,int iCount);
unsigned int TranslateNewLinesToUnixW(wchar_t *tbuf, unsigned int *tlen);

BOOL CALLBACK FindAndReplaceDlgProcW(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam);
int FindTextW(HWND hWndEdit);
int ReplaceTextW(HWND hWndEdit, BOOL all);
BOOL EscapeStringToEscapeDataW(wchar_t *input, wchar_t *output);
void EscapeDataToEscapeStringW(wchar_t *input, wchar_t *output);

void ReplaceSelA(HWND hWndEdit, char *pData);
void ReplaceSelW(HWND hWndEdit, wchar_t *pData);
DWORD CALLBACK ReplaceSelCallbackW(DWORD dwCookie, LPBYTE pbBuff, LONG cb, LONG *pcb);
wchar_t* GetSelTextW(HWND hWnd, CHARRANGE chrg);
void FreeSelTextW(wchar_t *pText);

BOOL CALLBACK GoToLineDlgProc(HWND hDlg, UINT uiMsg, WPARAM wParam, LPARAM lParam);

void RecentFilesZero();
void RecentFilesRead();
BOOL RecentFilesGet(char *file, int *position, int *codepage);
BOOL RecentFilesUpdate(char *file, int position, int codepage);
int RecentFilesDeleteDead();
void RecentFilesSave();
void RecentFilesMenu(HWND hWndEdit);
int TrimPath(char *szResult, char *pPath, int nMax);

void LanguageMenu(HWND hWndEdit);
char* GetBaseName(char *pFile, char *szBaseName);

BOOL isInDelimiterList(wchar_t c);
int CALLBACK EditWordBreakProc(LPTSTR pchText, int ichCurrent, int cch, int code);

BOOL CALLBACK OptionsDlgProc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam);

BOOL CALLBACK AboutDlgProc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam);

char* GetCommandLineParamsA();
int GetCommandLineArgA(char *lpCmdLine, char *szArg, char **lpNextArg);
BOOL SaveChanged(HWND hWndEdit);
int SetLayout();
void RestoreLayout(int reserv_layout);
void SetChosenFont(HWND hWndEdit);
void SetChosenFontColor(HWND hWndEdit);
void SetChosenFontSize(HWND hWndEdit);
int PixelsToTwips(HWND hWndEdit, int nPixels);
void SetInsertState(BOOL state);
void SetUnixNewLine(BOOL state);
void SetModify(BOOL state);
BOOL FileExists(char *fname);
int IsFile(char *fname);
void GetFileVersion(char *pFile, int *nMajor, int *nMinor, int *nRelease, int *nBuild);
int ParseExecCommand(char *pCommand, char *szBuffer, int nBufferSize);
void FreeMemorySearch();
void FreeMemoryRecentFiles();

HMENU API_LoadMenu(HINSTANCE hLoadInstance, LPCTSTR lpMenuName);
HACCEL API_LoadAccelerators(HINSTANCE hLoadInstance, LPCTSTR lpTableName);
HCURSOR API_LoadCursor(HINSTANCE hLoadInstance, LPCTSTR lpCursorName);
HICON API_LoadIcon(HINSTANCE hLoadInstance, LPCTSTR lpIconName);
int API_LoadString(HINSTANCE hLoadInstance, UINT uID, LPTSTR lpBuffer, int nBufferMax);
HWND API_CreateDialogParamA(HINSTANCE hLoadInstance, LPCTSTR lpTemplateName, HWND hWndParent, DLGPROC lpDialogFunc, LPARAM dwInitParam);
HWND API_CreateDialogParamW(HINSTANCE hLoadInstance, LPCWSTR lpTemplateName, HWND hWndParent, DLGPROC lpDialogFunc, LPARAM dwInitParam);
LPVOID API_HeapAlloc(HANDLE hHeap, DWORD dwFlags, SIZE_T dwBytes);
HANDLE API_CreateFile(LPCTSTR lpFileName, DWORD dwDesiredAccess, DWORD dwShareMode, LPSECURITY_ATTRIBUTES lpSecurityAttributes, DWORD dwCreationDisposition, DWORD dwFlagsAndAttributes, HANDLE hTemplateFile);
BOOL API_ReadFile(HANDLE hFile, LPVOID lpBuffer, DWORD nNumberOfBytesToRead, LPDWORD lpNumberOfBytesRead, LPOVERLAPPED lpOverlapped);
BOOL API_WriteFile(HANDLE hFile, LPCVOID lpBuffer, DWORD nNumberOfBytesToWrite, LPDWORD lpNumberOfBytesWritten, LPOVERLAPPED lpOverlapped);
BOOL API_SetWindowTextW(HWND hWnd, LPCWSTR lpString);
BOOL API_GetWindowTextLengthW(HWND hWnd);
int API_GetWindowTextW(HWND hWnd, LPWSTR lpString, int nMaxCount);
int API_lstrlenW(LPCWSTR lpString);
int API_lstrcmpW(LPCWSTR lpString1, LPCWSTR lpString2);
int API_lstrcmpiW(LPCWSTR lpString1, LPCWSTR lpString2);

#endif
